/*
 * CharacterStateDescription.java
 *
 * Created on 3. Mrz 2004, 15:40
 */

package net.metadiversity.diversity.navigator.db.delta_editor;

import net.metadiversity.diversity.navigator.gui.delta_editor.DeltaEditorChangeListener;

import org.apache.log4j.Logger;

/**
 *
 * @author  didi
 */
public class CharacterStateDescription extends java.lang.Object
{
    static Logger logger = Logger.getLogger( CharacterStateDescription.class.getName() ); 

    private boolean inappicalibleFlag;
    private boolean calculateFlag;

    private String  tableCellString = null;
    private String  editorString = null;
    
    // type of characterState
    
    private static final int TYPE_UNKNOWN   = 0x00;
    private static final int TYPE_TEXT      = 0x01;
    private static final int TYPE_NUMERICAL = 0x02;
    private static final int TYPE_SELECTION = 0x04;
    
    private int     characterType = TYPE_UNKNOWN;
    
    // Strings used for displaying data
    
    private String min  = null;
    private String low  = null;
    private String mean = null;
    private String high = null;
    private String max  = null;
    
    // Vector to store CharacterStateElements
    private java.util.Vector  states;                                
    
    /** Creates a new instance of CharacterStateDescription */
    public CharacterStateDescription()
    {
        states = new java.util.Vector();
        calculateFlag = true;
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public boolean add( CharacterStateDescriptionEntry e )
    {
        calculateFlag = true;
        return states.add( e );
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public boolean isInapplicalible()
    {
        return inappicalibleFlag;
    }    
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public void setInapplicalible( boolean b )
    {
        inappicalibleFlag = b;
    }
    //--------------------------------------------------------------------------
    // calculate all fields for this CharcaterState
    //--------------------------------------------------------------------------    
    public void calculate()
    {
        // variables used for numerical values
        String min  = null;
        String low  = null;
        String mean = null;
        String high = null;
        String max  = null;        
        StringBuffer cellResult = new StringBuffer();
        StringBuffer editResult = new StringBuffer();
        boolean first = true;
        characterType = TYPE_SELECTION; // ??? TYPE_UNKNOWN;
            
        for( int i = 0; i < states.size(); i++ )
        {    
            CharacterStateDescriptionEntry entry = (CharacterStateDescriptionEntry) states.get( i );
            String str = entry.getCS();
            
            if( first )
            {
                if( str.compareTo( "TE" ) == 0 )    // Text element
                {
                    str = entry.getText();
                    characterType = TYPE_TEXT;
                }
                else if( str.compareTo( "Min" ) == 0 ) // numerical values
                {
                    min = String.valueOf( entry.getX() );
                    characterType = TYPE_NUMERICAL;
                }
                else if( str.compareTo( "-Low" ) == 0 ) // numerical values
                {
                    low = String.valueOf( entry.getX() );
                    characterType = TYPE_NUMERICAL;
                }
                else if( str.compareTo( "Mean" ) == 0 ) // numerical values
                {
                    mean = String.valueOf( entry.getX() );
                    characterType = TYPE_NUMERICAL;
                }
                else if( str.compareTo( "+High" ) == 0 ) // numerical values
                {
                    high = String.valueOf( entry.getX() );
                    characterType = TYPE_NUMERICAL;
                }
                else if( str.compareTo( "Max" ) == 0 ) // numerical values
                {
                    max = String.valueOf( entry.getX() );
                    characterType = TYPE_NUMERICAL;
                }
            }

            switch( characterType )
            {
            case    TYPE_NUMERICAL:
                    break;
            case    TYPE_TEXT:
                    first = false;
                    cellResult.append( str );
                    break;
            case    TYPE_SELECTION:
                    if( ! first )
                    {
                        cellResult.append( "/" );
                    }
                    first = false;
                    cellResult.append( entry.getCS() );
                    break;
            default:
                    if( ! first )
                    {
                        cellResult.append( "/" );
                    }
                    else
                    {
                        cellResult.append( "Unkownd character type: " );
                    }                        
                    first = false;
                    cellResult.append( entry.getCS() );
                    break;
            }
        }
        
        if( characterType == TYPE_NUMERICAL )
        {
            // format String
            if( min != null )
            {
                cellResult.append( "(" + min + "-)" );
            }
            if( low != null )
            {
                cellResult.append( low );
            }
            if( mean != null )
            {
                // result.append( ">" + mean + "<" );
                cellResult.append( mean );
            }
            if( low != null && high != null )
            {
                cellResult.append( "-" ); 
            }
            if( high != null )
            {
                cellResult.append( high  );
            }
            if( max != null )
            {
                cellResult.append( "(-" + max + ")" );
            }
        }
        // set result
        calculateFlag = false;        
        tableCellString = cellResult.toString();
        editorString    = cellResult.toString();
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------    
    public String toString()
    {
        if( calculateFlag ) calculate();
        return tableCellString;
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------    
    public String getTableCellText()
    {
        if( calculateFlag ) calculate();
        return editorString;
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------    
    public java.util.Vector getDescriptionStatesVector()
    {
        return states;
    }
}
