/*
 * CharacterStateDescriptionEntry.java
 *
 * Created on 3. M�rz 2004, 15:10
 */

package net.metadiversity.diversity.navigator.db.delta_editor;

import org.apache.log4j.Logger;

/**
 *
 * @author  didi
 */
public class CharacterStateDescriptionEntry extends java.lang.Object
{
    static Logger logger = Logger.getLogger( CharacterStateDescriptionEntry.class.getName() ); 
    
    private int     iid;
    private int     cid;
    private String  modifier;
    private String  cs;
    private double  x;
    private String  text;
    private String  notes;
    private int     seq;
    
    private String  characterType;  // TE, OM, UM,...
            
    
    /** Creates a new instance of CharacterStateDescriptionEntry */
    public CharacterStateDescriptionEntry()
    {
    }
    public CharacterStateDescriptionEntry( int iid, int cid, String modifier, String cs, double x, String text, String notes, int seq, String characterType )
    {
        this.iid        = iid;
        this.cid        = cid;
        this.modifier   = (modifier == null) ? "" : modifier;
        this.cs         = (cs == null) ? "" : cs;
        this.x          = x;
        this.text       = (text == null) ? "" : text;
        this.notes      = (notes == null) ? "" : notes;
        this.seq        = seq;        
        this.characterType = characterType;
    }
    public CharacterStateDescriptionEntry( int iid, int cid, String cs, String characterType )
    {
        this.iid        = iid;
        this.cid        = cid;
        this.modifier   = "";
        this.cs         = cs;
        this.x          = 0;
        this.text       = "";
        this.notes      = "";
        this.seq        = 0;
        this.characterType = characterType;
    }
    //--------------------------------------------------------------------------
    public int getIID()
    {
        return iid;
    }
    public int getCID()
    {
        return cid;
    }
    public String getModifier()
    {
        return modifier;
    }
    public String getCS()
    {
        return cs;
    }
    public double getX()
    {
        return x;
    }
    public String getText()
    {
        return text;
    }
    public String getNotes()
    {
        return notes;
    }
    public int getSEQ()
    {
        return seq;
    }
    //--------------------------------------------------------------------------
    public void setIID( int val )
    {
        iid = val;
    }
    public void setCID( int val )
    {
        cid = val;
    }
    public void setModifier( String str )
    {
        modifier = str;
    }
    public void setCS( String str )
    {
        cs = str;
    }
    public void setX( double val )
    {
        x = val;
    }
    public void setText( String str )
    {
        text = str;
    }
    public void setNotes( String str )
    {
        notes = str;
    }
    public void setSEQ( int val )
    {
        seq = val;
    }
    //--------------------------------------------------------------------------
    public boolean isTextElement()
    {
        return characterType.equals( "TE" );
    }
}
