/*
 * UbtCollectionMainFrame.java
 *
 * Created on 15. Januar 2003, 19:58
 */

package net.metadiversity.diversity.navigator.db.ub;

import org.apache.log4j.Logger;

import net.metadiversity.diversity.navigator.db.ub.collection.*;
import net.metadiversity.diversity.navigator.connection.ConnectionInfo;

import net.metadiversity.diversity.navigator.db.CollectionBayreuthHibernate;
/**
 *
 * @author  didi
 */
public class UbtCollectionMainFrame extends javax.swing.JPanel // javax.swing.JInternalFrame //javax.swing.JFrame // 
{
    static Logger logger = Logger.getLogger( UbtCollectionMainFrame.class );
    
    UbtCollectionHeader     header;
    UbtCollectionImage      image;
    UbtCollectionTabs_096   tabs;
    DnDataRecordSelector    records;
    javax.swing.JPanel      bottonPanel;
    
    net.metadiversity.diversity.navigator.db.CollectionBayreuthHibernate collection;
    
    static final boolean USE_HIBERNATE = true;
    
    /** Creates a new instance of UbtCollectionMainFrame */
    public UbtCollectionMainFrame( ConnectionInfo ci ) 
    {
        
        try
        {
            if( USE_HIBERNATE )
            {
                collection = new CollectionBayreuthHibernate( ci );
            }
        }
        catch ( java.lang.Exception ex )
        {
            ex.printStackTrace();
        }    
        initComponents();
        try
        {
            long count = collection.getCollectionSpecimenCount();
            System.out.println( "Entries : " +  count );
            records.setRecordMaxValue( count );
            // read first entry  
            records.setTabs( tabs );
            tabs.setCollection( collection );
            tabs.update( 0 );
            setVisible( true );
        }
        catch ( java.lang.Exception ex )
        {
            ex.printStackTrace();
        }    
    }
    private void initComponents() 
    {
        setLayout( new java.awt.BorderLayout() );

        // Header
        header = new UbtCollectionHeader();
        add( header, java.awt.BorderLayout.NORTH );        
        // image ---------------------------------------------------------------
        image = new UbtCollectionImage();
        add( image, java.awt.BorderLayout.CENTER );        
        // bottom --------------------------------------------------------------
// ???        tabs    = new UbtCollectionTabs();
        tabs    = new UbtCollectionTabs_096();
        records = new DnDataRecordSelector();
        
        bottonPanel = new javax.swing.JPanel();
        bottonPanel.setPreferredSize( new java.awt.Dimension( 640, 290 ) );
        bottonPanel.setLayout( new java.awt.BorderLayout() );
        bottonPanel.add( tabs, java.awt.BorderLayout.CENTER );
        bottonPanel.add( records, java.awt.BorderLayout.SOUTH );
        add( bottonPanel, java.awt.BorderLayout.SOUTH );

        records.addActionListener( new java.awt.event.ActionListener() 
        {
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            {
                recordsActionPerformed( evt );
            }
        });
        //----------------------------------------------------------------------
        try
        {
            long count = collection.getCollectionSpecimenCount();
            logger.debug( "Entries : " +  count );
            records.setRecordMaxValue( count );
            // read first entry  
            records.setTabs( tabs );
            tabs.setCollection( collection );
            tabs.update( 0 );
        }
        catch ( java.lang.Exception ex )
        {
            ex.printStackTrace();
        }            
    }
    
    private void recordsActionPerformed(java.awt.event.ActionEvent evt) 
    {
        // Data record changed
        System.out.println( "record changed" );
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) 
    {
        javax.swing.JFrame frame = new javax.swing.JFrame();

        net.metadiversity.diversity.navigator.connection.ConnectionInfo ci;
        
        ci = new ConnectionInfo( "name", "Description", "org.postgresql.Driver", "jdbc:postgresql://141.84.65.158:5432/DiversityCollection_BIOTAlichencoll", "didi", "pwd" );
        
        UbtCollectionMainFrame cf = new UbtCollectionMainFrame( ci );        
        
        try
        {
            frame.getContentPane().add( cf );
            frame.setSize( 640, 480 );
            frame.pack();
            frame.show();
        }
        catch ( java.lang.Exception ex )
        {
            ex.printStackTrace();
        }    
    }    
}
