/*
 * UbtCollectionTabs.java
 *
 * Created on 14. Januar 2003, 17:46
 */

package net.metadiversity.diversity.navigator.db.ub;

import net.metadiversity.diversity.navigator.hibernate.ubt.collection.*;

// Tabs
import net.metadiversity.diversity.navigator.gui.CollectionTabIndentification;
import net.metadiversity.diversity.navigator.gui.CollectionTabGeographicData;
import net.metadiversity.diversity.navigator.gui.CollectionTabMiscellaneous;
import net.metadiversity.diversity.navigator.gui.CollectionTabCollectorTimeLocation;

import org.apache.log4j.Logger;

/**
 *
 * @author  didi
 */
public class UbtCollectionTabs_096 extends javax.swing.JPanel 
{
    static Logger logger = Logger.getLogger( UbtCollectionTabs_096.class.getName() );
    
    net.metadiversity.diversity.navigator.db.CollectionBayreuthHibernate                 hibernateCollection;

    //----------
    // hibernate 
    //----------
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionSpecimen  specimen;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionGeography geography;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectingPerson    person;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.Identification      identification;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.IdentificationUnit  identificationUnit;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionProject   project;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionStorage   storage;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionDuplicate duplicate;
    //
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollDateCategoryEnum            categoryEnum;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollIdentificationCategoryEnum  identificationCategoryEnum;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollIdentificationQualifierEnum identificationQualifierEnum;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollLabelTypeEnum               labelTypeEnum;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollLabelTranscriptionEnum      labelTranscriptionEnum;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollTaxonomicGroupEnum          taxonomicGroupEnum;
    //-----------
    // GUI tabs
    //-----------
    CollectionTabCollectorTimeLocation  p1;
    CollectionTabGeographicData         p2;
    CollectionTabIndentification        p3;   
    CollectionTabMiscellaneous          p4;
    /** Creates new form UbtCollectionTabs */
    public UbtCollectionTabs_096() 
    {
        initComponents();
        
        p1 = new CollectionTabCollectorTimeLocation();
        javax.swing.JPanel jPanelCollectorTimeLocation = p1.getPanel();
        javax.swing.JScrollPane         s1 = new javax.swing.JScrollPane( jPanelCollectorTimeLocation );
        
        p2 = new CollectionTabGeographicData();
        javax.swing.JPanel jPanelGeographicData = p2.getPanel();
        javax.swing.JScrollPane         s2 = new javax.swing.JScrollPane( jPanelGeographicData );
        //
        p3 = new CollectionTabIndentification();
        javax.swing.JPanel jPanelIdentification = p3.getPanel();
        javax.swing.JScrollPane         s3 = new javax.swing.JScrollPane( jPanelIdentification );
        //
        p4 = new CollectionTabMiscellaneous();
        javax.swing.JPanel jPanelMiscellaneousData = p4.getPanel();
        javax.swing.JScrollPane         s4 = new javax.swing.JScrollPane( jPanelMiscellaneousData );
        
        //
        jTabbedPaneCollectionTabs.removeAll();
        
        jTabbedPaneCollectionTabs.addTab( "Collector, time and location", s1 );
        jTabbedPaneCollectionTabs.addTab( "Geograpic data", s2 );
        jTabbedPaneCollectionTabs.addTab( "Identification", s3 );
        jTabbedPaneCollectionTabs.addTab( "Miscellaneous",  s4 );
        
    }
    public void setCollection( net.metadiversity.diversity.navigator.db.CollectionBayreuthHibernate c )
    {
        hibernateCollection = c;
        
//        setLocalisationSystemModel( c.getLocalisationModel() );

    }
/*    
    public void setLocalisationSystemModel( javax.swing.ComboBoxModel model )
    {
//???        jComboBoxGdLocalisatinSystem.setModel( model );
    }    
 */
    // Update GUI Data for    
    public void update( int index )
    {
        try
        {
            if( hibernateCollection != null )
            {
                
                specimen    = hibernateCollection.getCollectionSpecimen( index );
                
                
                // geography   = hibernateCollection.getCollectionGeography( index );

                //----------------
                // Project
                //----------------
                java.util.Set projectSet = specimen.getCollectionProjects();
                java.util.Iterator iterProject = projectSet.iterator();
                if( iterProject.hasNext() )
                {
                    project = ( CollectionProject ) iterProject.next();
                }
                else
                {                
                    project = new CollectionProject();
                }
                
                //----------------
                // Person Groups
                //----------------
                java.util.Set personSet = specimen.getCollectingPersons();                
                java.util.Iterator iterPerson = personSet.iterator();
                if( iterPerson.hasNext() )
                {
                    person = ( CollectingPerson ) iterPerson.next();
                }
                else
                {                
                    person = new CollectingPerson();
                }
                //------------
                // geography
                //------------                
                java.util.Set geographySet = specimen.getCollectionGeographies();                
                java.util.Iterator iterGeo = geographySet.iterator();
                if( iterGeo.hasNext() )
                {
                    geography = ( CollectionGeography ) iterGeo.next();
                }
                else
                {                
                    geography = new CollectionGeography();
                }
                //---------------------
                // Identification Units
                //---------------------
                java.util.Set identificationUnitsSet = specimen.getIdentificationUnits();                
                java.util.Iterator iterUnit = identificationUnitsSet.iterator();
                
                if( iterUnit.hasNext() )
                {
                    identificationUnit = ( IdentificationUnit ) iterUnit.next();
                }
                else
                {
                    identificationUnit = new net.metadiversity.diversity.navigator.hibernate.ubt.collection.IdentificationUnit();
                }            
                //---------------------
                // Identification 
                //---------------------
                java.util.Set identificationSet = identificationUnit.getIdentifications();                
                java.util.Iterator iterIdentification = identificationSet.iterator();
                
                if( iterIdentification.hasNext() )
                {
                    identification = ( Identification ) iterIdentification.next();
                }
                else
                {
                    identification = new net.metadiversity.diversity.navigator.hibernate.ubt.collection.Identification();
                }                                            
                
                //---------------------
                // Storage
                //---------------------
                java.util.Set storageSet = specimen.getCollectionStorages();                
                java.util.Iterator iterStorage = storageSet.iterator();
                
                if( iterStorage.hasNext() )
                {
                    storage = ( CollectionStorage ) iterStorage.next();
                }
                else
                {
                    storage = new net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionStorage();
                }
                //----------------------
                // CollectionDuplicate
                //----------------------
                java.util.Set duplicateSet = specimen.getCollectionDuplicates();                
                java.util.Iterator iterDuplicate = duplicateSet.iterator();
                
                if( iterDuplicate.hasNext() )
                {
                    duplicate = ( CollectionDuplicate ) iterDuplicate.next();
                }
                else
                {
                    duplicate = new net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionDuplicate();
                }
                
                //-----------------------------------------
                // Setup selection models 
                //-----------------------------------------
                p1.getJComboBoxDateCategory().setModel( hibernateCollection.getNewDateCategoryModel() );
                p3.getJComboBoxDataCategory().setModel( hibernateCollection.getNewDateCategoryModel() );
                p4.getJComboBoxDateCategory().setModel( hibernateCollection.getNewDateCategoryModel() );
                
                p1.getJComboBoxLabelType().setModel(     hibernateCollection.getNewLabelTypeModel()    );
                p1.getJComboBoxLableTranscription().setModel(     hibernateCollection.getNewLabelTranscriptionModel() );
                
                p1.getJComboBoxPersonOrGroups().setModel( hibernateCollection.getNewPersonModel() );
                p1.getJComboBoxProject().setModel( hibernateCollection.getNewProjectModel() );
                
                p2.getJComboBoxLocationSystem().setModel( hibernateCollection.getNewLocalisationModel() );
                p2.getJComboBoxResponsible().setModel( hibernateCollection.getNewPersonModel() );
                
                p3.getJComboBoxCategory().setModel(     hibernateCollection.getNewIdentificationCategoryModel()    );
                p3.getJComboBoxQualifier().setModel(    hibernateCollection.getNewIdentificationQualifierModel()   );
                // p3.getJComboBoxGrowingLivingOn()
                p3.getJComboBoxResponsible().setModel( hibernateCollection.getNewPersonModel() );
                p3.getJComboBoxTaxonomicGroup().setModel(    hibernateCollection.getNewTaxonomicGroupModel()       );
                p3.getJComboBoxTaxonomicName().setModel(    hibernateCollection.getNewTaxonomicNameModel()         );
                p3.getJComboBoxTypifiedTaxonAndState().setModel(    hibernateCollection.getNewTypeStatusModel()    );
                                
                p4.getJComboBoxCollection().setModel( hibernateCollection.getNewCollectionModel()  );
                // p4.getJComboBoxDepositorName()
                p4.getJComboBoxDuplicatesCollection().setModel( hibernateCollection.getNewCollectionModel()  );
                p4.getJComboBoxMaterialCategory().setModel( hibernateCollection.getNewMaterialCategoryModel() );
                                
                //-----------------------------------------
                // Tab-Sheet (1) Collector, time and location                
                //-----------------------------------------
                setComboBoxSelection( p1.getJComboBoxPersonOrGroups(), person.getComp_id().getCollectorsName() );
                //
                setFieldData( p1.getJTextFieldCollectionNumber(),    person.getCollectorsNumber()   );
                // ??? Project
                // ??? String projectSelection = project.
                setComboBoxSelection( p1.getJComboBoxProject(),      project.getComp_id().getDiversityProject() );
                
                //
                setFieldData( p1.getJTextFieldDateDD(),              specimen.getCollectionDay()    );
                setFieldData( p1.getJTextFieldDateMM(),              specimen.getCollectionMonth()  );
                setFieldData( p1.getJTextFieldDateYYYY(),            specimen.getCollectionYear()   );
                setFieldData( p1.getJTextFieldDateSuppl(),           specimen.getCollectionDateSupplement() );
                //
                categoryEnum = (XcollDateCategoryEnum) specimen.getXcollDateCategoryEnumByAccessionDateCategory();
                setComboBoxSelection( p1.getJComboBoxDateCategory(), (categoryEnum != null) ? categoryEnum.getCode() : null );
                //
                setFieldData( p1.getJTextFieldLabelTitle(),          specimen.getLabelTitle()       );
                //
                labelTranscriptionEnum = (XcollLabelTranscriptionEnum) specimen.getXcollLabelTranscriptionEnum();
                setComboBoxSelection( p1.getJComboBoxLableTranscription(), (labelTranscriptionEnum != null) ? labelTranscriptionEnum.getCode() : null );
                //
                labelTypeEnum = (XcollLabelTypeEnum) specimen.getXcollLabelTypeEnum();
                setComboBoxSelection( p1.getJComboBoxLabelType(), (labelTypeEnum != null) ? labelTypeEnum.getCode() : null );
                //
                setFieldData( p1.getJCheckBoxPrintLabel(),           specimen.getPrintLabel()       );
                setFieldData( p1.getJTextPaneLabelNotes(),           specimen.getLabelTranscriptionNotes() );
                //
                setFieldData( p1.getJTextPaneLocalityHabitat(),      specimen.getLocalityDescription()  );
                setFieldData( p1.getJTextPaneOriginalNotes(),        specimen.getOriginalNotes()    );
                setFieldData( p1.getJTextPaneAreaAdditionalNotes(),  specimen.getAdditionalNotes()  );
                setFieldData( p1.getJTextPaneProblems(),             specimen.getProblems()         );
//                setFieldData( p1 );
                //-----------------------------------------
                // Tab-Sheet (2) GeographicData
                //-----------------------------------------                
                setFieldData( p2.getJTextPaneLocalityHabitat(),     specimen.getLocalityDescription() );
                //------------------------------------------
                setFieldData( p2.getJTextFieldDate(),               geography.getDeterminationDate()  );
                //------------------------------------------                
                setFieldData( p2.getJTextFieldLatitude(),           geography.getLocation1() );
                //------------------------------------------                                
                setFieldData( p2.getJTextFieldLongitude(),          geography.getLocation2() );
                // Problems
                setFieldData( p2.getJTextPaneLocalityProblems(),    specimen.getProblems() );                               
                // LocalisatinSystem
                // System.out.println( ((LocalisationSystem) geography.getLocalisationSystem()).getLocalisationSystemName() );
                setComboBoxSelection( p2.getJComboBoxLocationSystem(), ((LocalisationSystem) geography.getLocalisationSystem()).getLocalisationSystemName() );
                //
                setComboBoxSelection( p2.getJComboBoxResponsible(), geography.getResponsible() );
                //-----------------------------------------
                // Tab-Sheet (3) Indentification
                //-----------------------------------------
//                setComboBoxSelection( p1.getJComboBoxLabelType(), (labelTypeEnum != null) ? labelTypeEnum.getCode() : null );
                
                // Taxonomic group
                taxonomicGroupEnum = identificationUnit.getXcollTaxonomicGroupEnum();
                setComboBoxSelection( p3.getJComboBoxTaxonomicGroup(), (taxonomicGroupEnum != null) ? taxonomicGroupEnum.getCode() : null        );
                //
                setFieldData( p3.getJTextFieldTypifiedTaxonAndState(),  identificationUnit.getTypifiedTaxon()   );
                // ??? identificationUnit.getXcollTypeStatusEnum()
                // setFieldData( p3.getJComboBoxTypifiedTaxonAndState(),   )
                //
                setComboBoxSelection( p3.getJComboBoxTaxonomicName(),   identification.getTaxonomicName()       );
                //
                setFieldData( p3.getJTextFieldVernacularName(),         identification.getVernacularName()      );
                //
                setFieldData( p3.getJTextFieldDateDD(),                 identification.getIdentificationDay()   );
                setFieldData( p3.getJTextFieldDateMM(),                 identification.getIdentificationMonth() );
                setFieldData( p3.getJTextFieldDateYYYY(),               identification.getIdentificationYear()  );  
                setFieldData( p3.getJTextFieldDateSupl(),               identification.getIdentificationDateSupplement() );
                //--------------------------------------------------------------
                categoryEnum = (XcollDateCategoryEnum) identification.getXcollDateCategoryEnum();
                setComboBoxSelection( p3.getJComboBoxDataCategory(), (categoryEnum != null) ? categoryEnum.getCode() : null );
                //--------------------------------------------------------------
                identificationCategoryEnum = (XcollIdentificationCategoryEnum) identification.getXcollIdentificationCategoryEnum();
                setComboBoxSelection( p3.getJComboBoxCategory(), (identificationCategoryEnum != null) ? identificationCategoryEnum.getCode() : null );
                //--------------------------------------------------------------
                identificationQualifierEnum = (XcollIdentificationQualifierEnum) identification.getXcollIdentificationQualifierEnum();
                setComboBoxSelection( p3.getJComboBoxQualifier(), (identificationQualifierEnum != null) ? identificationQualifierEnum.getCode() : null );
                //
                setFieldData( p3.getJTextFieldLiteratureUsed(), identification.getLiteratureUsed() );
                //
                setComboBoxSelection( p3.getJComboBoxResponsible(), identification.getResponsibleName() );
                // Exsiccatum
                setFieldData( p3.getJCheckBoxExsiccatum(),          identification.getIsexsiccataTaxon() );
                // Notes
                setFieldData( p3.getJTextFieldNotes(),              identification.getNotes()           );
                //
                setFieldData( p3.getJTextFieldColonizedPart(),      identificationUnit.getColonisedPart() );
                // ???
                setComboBoxSelection( p3.getJComboBoxGrowingLivingOn(), identificationUnit.getColonisedPart() );
                setFieldData( p3.getJTextFieldLifeState(),          identificationUnit.getLifeStage() );                
                setFieldData( p3.getJTextFieldNotes2(),             identificationUnit.getNotes() );
                //--------------------------------------------------------------
                //-----------------------------------------
                // Tab-Sheet (4)  Miscellaneous
                //-----------------------------------------
                // Storage
                // ??? setComboBoxSelection( p4.getJComboBoxCollection(),  storage 
                setFieldData( p4.getJTextFieldStorageLocationE_G(), storage.getStorageLocation() );
                setComboBoxSelection( p4.getJComboBoxMaterialCategory(), storage.getComp_id().getMaterialCategory() );
                // Duplicates
                // ??? setComboBoxSelection( p4.getJComboBoxDuplicatesCollection(), duplicate.)
// ???                setFieldData( p4.getJTextFieldAccessionNumber(),    duplicate.getComp_id().getAccessionNumber() );
                setFieldData( p4.getJTextFieldDuplicatesNotes(),    duplicate.getNotes() );
// ???                
                // Exsiccata
                setFieldData( p4.getJTextFieldExsicAbbrev(),        specimen.getExsiccataAbbreviation() );
                setFieldData( p4.getJTextFieldExsicNr(),            specimen.getExsiccataNumber()       );
//???                setFieldData( p4.getJCheckBoxIsExsccate(),          specimen.get );
                // Accession
                setFieldData( p4.getJTextFieldAccessionNr(),        specimen.getAccessionNumber()   );
                setFieldData( p4.getJTextFieldDateDD(),             specimen.getAccessionDay()      );
                setFieldData( p4.getJTextFieldDateMM(),             specimen.getAccessionMonth()    );
                setFieldData( p4.getJTextFieldDateYYYY(),           specimen.getAccessionYear()     );
                setFieldData( p4.getJTextFieldDateSup(),            specimen.getAccessionDateSupplement() );
                // descriptor
                setFieldData( p4.getJTextFieldDepositorNr(),        specimen.getDepositorsAccessionNumber() );
                // Borrow and loan
                setFieldData( p4.getJTextPaneBorrowLoan(),          specimen.getLoanInformation() );                
            }
        }    
        catch ( java.lang.Exception ex )
        {
            ex.printStackTrace();
        }    
        
    }
    //--------------------------------------------------------------------------
    private void setComboBoxSelection( javax.swing.JComboBox cb, java.lang.String selection )
    {
        if( selection == null )
        {
            cb.setSelectedItem( "" );
        }
        else
        {
            cb.setSelectedItem( selection );            
        }
    }
    //--------------------------------------------------------------------------
    private void setFieldData( javax.swing.JCheckBox field, java.lang.Boolean b )
    {
        if( b == null )
        {
            // ??? field.setText( "" );
        }
        else
        {
            field.setSelected( b.booleanValue() );
        }
    }
    //--------------------------------------------------------------------------
    private void setFieldData( javax.swing.JTextField field, java.util.Date date )
    {
        java.lang.String str = date.toString();
        if( str == null )
        {
            field.setText( "" );
        }
        else
        {
            field.setText( str );
        }
        field.select( 0, 0 );        
    }
    //--------------------------------------------------------------------------
    private void setFieldData( javax.swing.JTextField field, java.lang.String str )
    {
        if( str == null )
        {
            field.setText( "" );
        }
        else
        {
            field.setText( str );
        }
        field.select( 0, 0 );        
    }
    //--------------------------------------------------------------------------
    private void setFieldData( javax.swing.JTextPane field, java.lang.String str )
    {
        if( str == null )
        {
            field.setText( "" );
        }
        else
        {
            field.setText( str );
        }
        field.select( 0, 0 );        
    }
    //--------------------------------------------------------------------------
    private void setFieldData( javax.swing.JTextField field, Integer val )
    {
        if( val == null )
        {
            field.setText( "" );
        }
        else
        {
            field.setText( val.toString() );
        }
        field.select( 0, 0 );        
    }
    //--------------------------------------------------------------------------
    private void setFieldData( javax.swing.JTextField field, Short val )
    {
        if( val == null )
        {
            field.setText( "" );
        }
        else
        {
            field.setText( val.toString() );
        }
        field.select( 0, 0 );        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        javax.swing.ButtonGroup buttonGroupType;

        buttonGroupType = new javax.swing.ButtonGroup();
        jTabbedPaneCollectionTabs = new javax.swing.JTabbedPane();

        setLayout(new java.awt.BorderLayout());

        setPreferredSize(new java.awt.Dimension(640, 234));
        jTabbedPaneCollectionTabs.setMinimumSize(new java.awt.Dimension(640, 189));
        add(jTabbedPaneCollectionTabs, java.awt.BorderLayout.CENTER);

    }//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane jTabbedPaneCollectionTabs;
    // End of variables declaration//GEN-END:variables
    
    private DnDataRecordSelector indentificationRecord;

}
