package net.metadiversity.diversity.navigator.db.ub.castor.collection;

import net.metadiversity.diversity.navigator.db.ub.collection.*;

import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;

import java.io.PrintWriter;
import java.io.InputStreamReader;
import java.io.Serializable;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.DriverManager;

import org.xml.sax.ContentHandler;

import org.exolab.castor.jdo.JDO;
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.OQLQuery;
import org.exolab.castor.jdo.QueryResults;
import org.exolab.castor.util.Logger;
import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.mapping.Mapping;

import org.apache.xml.serialize.*;

/**
 *
 * @author  didi
 */
public class CollectionBayreuth 
{    
    
    public static final String DatabaseFile = "database.xml";
    public static final String MappingFile  = "mapping.xml";
    
    public static final String Usage = "Usage: example jdo";
    
    private Mapping  _mapping;
    private JDO      _jdo;

    private long    collectionSpecimenCount;
    private Vector  collectionSpecimenIds;
    
    private static PrintWriter         writer;
    private static CollectionBayreuth  collection;
    
    private        Database      db;

    /**
     * @param args the command line arguments
     */
    public static void main( String[] args )
    {
        try 
        {
            collection = new CollectionBayreuth();
            collection.init();
            X_CollectionSpecimen test = collection.getCollectionSpecimen( 5 ); 
        } 
        catch ( Exception except ) 
        {
            writer.println( except );
            except.printStackTrace( writer );
        }
    }

    /** Creates a new instance of TestCastorCollectionBayreuth */
    public CollectionBayreuth() throws Exception
    {
        writer = new Logger( System.out ).setPrefix( "collection" );
        // Load the mapping file
        _mapping = new Mapping( getClass().getClassLoader() );
        _mapping.setLogWriter( writer );
        _mapping.loadMapping( getClass().getResource( MappingFile ) );

        _jdo = new JDO();
        _jdo.setLogWriter( writer );
        _jdo.setConfiguration( getClass().getResource( DatabaseFile ).toString() );
        _jdo.setDatabaseName( "ub-collection" );
       
        collectionSpecimenIds = new Vector();
    }


    public void init() throws Exception
    {
        
        // tables
        
        net.metadiversity.diversity.navigator.db.ub.collection.X_CollectingPerson             person;
        net.metadiversity.diversity.navigator.db.ub.collection.X_CollectingPersonDescriptor   personDescriptor;
        
        net.metadiversity.diversity.navigator.db.ub.collection.CollectionBayreuth             bayreuth;
        net.metadiversity.diversity.navigator.db.ub.collection.CollectionBayreuthDescriptor   bayreuthDescriptor;

        net.metadiversity.diversity.navigator.db.ub.collection.X_CollectionSpecimen           specimen;
        net.metadiversity.diversity.navigator.db.ub.collection.X_CollectionSpecimenDescriptor specimenDescriptor;
        /*
        net.metadiversity.diversity.navigator.db.ub.collection
        net.metadiversity.diversity.navigator.db.ub.collection
        net.metadiversity.diversity.navigator.db.ub.collection
        net.metadiversity.diversity.navigator.db.ub.collection
        net.metadiversity.diversity.navigator.db.ub.collection
        net.metadiversity.diversity.navigator.db.ub.collection
        net.metadiversity.diversity.navigator.db.ub.collection
        net.metadiversity.diversity.navigator.db.ub.collection
        */
        
        //queries
        OQLQuery      personOql;
        OQLQuery      specimenOql;
        OQLQuery      getSpecimenOql;
        OQLQuery      specimenCountOql;
        OQLQuery      cOql;
        QueryResults  results;

        db = _jdo.getDatabase();
        db.begin();
        writer.println( "Begin transaction" );        
        // How may entries are in CollectionSpecimen ?
        specimenCountOql = db.getOQLQuery( "SELECT COUNT(*)  FROM net.metadiversity.diversity.navigator.db.ub.collection.X_CollectionSpecimen s" );
        results = specimenCountOql.execute();
                
        while ( ( results != null ) && results.hasMore() ) 
        {
            Object obj = results.next();
            collectionSpecimenCount = ((Long) obj).longValue();
            writer.println( "Table CollectionSpeciment has " +  collectionSpecimenCount + " entries" );            
        }        
        // Checkpoint commits all the updates to the database
        // but leaves the transaction (and locks) open
        writer.println( "Commit transaction" );
        db.commit();
        writer.println( "End" );
/*       
        personOql = db.getOQLQuery( "SELECT p FROM net.metadiversity.diversity.navigator.db.ub.collection.X_CollectingPerson p" );
        results = personOql.execute();
        while ( ( results != null ) && results.hasMore() ) 
        {
            person = ( X_CollectingPerson ) results.next();
            writer.println( "Person: "+ person.getCollectorsName() + " " + 
                                        person.getCollectionSpecimenID() + " " +
                                        person.getCollectorsNumber() + " " +
                                        person.getCollectorsSequence()
                                        );
        }
       
        writer.println( "Transaction checkpoint" );
*/       
        db.begin();
        getSpecimenOql = db.getOQLQuery( "SELECT s FROM net.metadiversity.diversity.navigator.db.ub.collection.X_CollectionSpecimen s" );
        results = getSpecimenOql.execute();
        while ( ( results != null ) && results.hasMore() ) 
        {
            specimen = ( X_CollectionSpecimen ) results.next();            
            collectionSpecimenIds.add( new Integer( specimen.getCollectionSpecimenID() ) );
            /*
            writer.println( "Specimen:" + " " + specimen.getCollectionSpecimenID()
                                        + " " + specimen.getAccessionDate() 
                                        + " " + specimen.getAccessionNumber()          
                                        + " " + specimen.getAdditionalNotes()
                                        + " " + specimen.getCollectionDate()
                                        + " " + specimen.getCollectionDateSupplement()
                                        + " " + specimen.getCollectionDay()
                                        + " " + specimen.getCollectionMonth()
                                        + " " + specimen.getCollectionYear()
                                        + " " + specimen.getCollectionName()
                                        + " " + specimen.getPrintLabel()          
                                        + " " + specimen          
                                        + " " + specimen          
                            );
             */
        }        
        // Checkpoint commits all the updates to the database
        // but leaves the transaction (and locks) open
        writer.println( "Commit transaction" );
        db.commit();
        writer.println( "End" );
// test 
        
        db.begin();
        specimen = null;;        
        writer.println( "Begin transaction" );
        specimenOql = db.getOQLQuery( "SELECT s FROM net.metadiversity.diversity.navigator.db.ub.collection.X_CollectionSpecimen s  WHERE CollectionSpecimenID = $1" );
        int id = ((Integer) collectionSpecimenIds.get( 1 ) ).intValue();
        writer.println( "select ID = " + id );
        specimenOql.bind( id );
        results = specimenOql.execute();
        if( ( results != null ) && results.hasMore() ) 
        {
            specimen = ( X_CollectionSpecimen ) results.next();            
        }
        writer.println( "Commit transaction" );
        db.commit();
        writer.println( "End" );
        db.close();
        
            writer.println( "Specimen:" + " " + specimen.getCollectionSpecimenID()
                                        + " " + specimen.getAccessionDate() 
                                        + " " + specimen.getAccessionNumber()          
                                        + " " + specimen.getAdditionalNotes()
                                        + " " + specimen.getCollectionDate()
                                        + " " + specimen.getCollectionDateSupplement()
                                        + " " + specimen.getCollectionDay()
                                        + " " + specimen.getCollectionMonth()
                                        + " " + specimen.getCollectionYear()
                                        + " " + specimen.getCollectionName()
                                        + " " + specimen.getPrintLabel()          
                                        /*
                                        + " " + specimen          
                                        + " " + specimen          
                                         */
                            );
    }

    public long getCollectionSpecimenCount()
    {
        return collectionSpecimenCount;
    }
    
    public X_CollectionSpecimen getCollectionSpecimen( int index ) throws Exception
    {
        X_CollectionSpecimen specimen = null;;
        QueryResults  results;
        OQLQuery      specimenOql;
        db = _jdo.getDatabase();
        db.begin();
        writer.println( "Begin transaction" );
        specimenOql = db.getOQLQuery( "SELECT s FROM net.metadiversity.diversity.navigator.db.ub.collection.X_CollectionSpecimen s  WHERE CollectionSpecimenID = $1" );
        int id = ((Integer) collectionSpecimenIds.get( index ) ).intValue();
        specimenOql.bind( id );
        results = specimenOql.execute();
        if( ( results != null ) && results.hasMore() ) 
        {
            specimen = ( X_CollectionSpecimen ) results.next();            
        }
        writer.println( "Commit transaction" );
        db.commit();
        writer.println( "End" );
        
            writer.println( "Specimen:" + " " + specimen.getCollectionSpecimenID()
                                        + " " + specimen.getAccessionDate() 
                                        + " " + specimen.getAccessionNumber()          
                                        + " " + specimen.getAdditionalNotes()
                                        + " " + specimen.getCollectionDate()
                                        + " " + specimen.getCollectionDateSupplement()
                                        + " " + specimen.getCollectionDay()
                                        + " " + specimen.getCollectionMonth()
                                        + " " + specimen.getCollectionYear()
                                        + " " + specimen.getCollectionName()
                                        + " " + specimen.getPrintLabel()          
                                        /*
                                        + " " + specimen          
                                        + " " + specimen          
                                         */
                            );
        writer.println( "End getCollectionSpecimen()" );
        db.close();
        return specimen;
    }
}
    
