/*
 * TestUsers.java
 *
 * Created on 28. November 2002, 12:51
 */

package net.metadiversity.diversity.navigator.db.ub.castor.users;

import net.metadiversity.diversity.navigator.db.ub.users.*;

import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;

import java.io.PrintWriter;
import java.io.InputStreamReader;
import java.io.Serializable;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.DriverManager;

import org.xml.sax.ContentHandler;

import org.exolab.castor.jdo.JDO;
import org.exolab.castor.jdo.Database;
import org.exolab.castor.jdo.OQLQuery;
import org.exolab.castor.jdo.QueryResults;
import org.exolab.castor.util.Logger;
import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.mapping.Mapping;

import org.apache.xml.serialize.*;


/**
 *
 * @author  didi
 */
public class TestUsers 
{    
    
    public static final String DatabaseFile = "database.xml";
    public static final String MappingFile  = "mapping.xml";
    
    public static final String Usage = "Usage: example jdo";
    
    private Mapping  _mapping;
    private JDO      _jdo;

    /**
     * @param args the command line arguments
     */
    public static void main( String[] args )
    {
        PrintWriter   writer;
        TestUsers     users;
        
        writer = new Logger( System.out ).setPrefix( "users" );
        try 
        {
            users = new TestUsers( writer );
            users.run( writer );
        } 
        catch ( Exception except ) 
        {
            writer.println( except );
            except.printStackTrace( writer );
        }
    }

    /** Creates a new instance of TestUsers */
    public TestUsers(PrintWriter writer) throws Exception
    {
        // Load the mapping file
        
        _mapping = new Mapping( getClass().getClassLoader() );
        _mapping.setLogWriter( writer );
        _mapping.loadMapping( getClass().getResource( MappingFile ) );

        _jdo = new JDO();
        _jdo.setLogWriter( writer );
        _jdo.setConfiguration( getClass().getResource( DatabaseFile ).toString() );
        _jdo.setDatabaseName( "ubt-users" );
       
    }


    public void run( PrintWriter writer ) throws Exception
    {
        Database      db;
        
        // tables
        
        net.metadiversity.diversity.navigator.db.ub.users.X_UserInfo            userInfo;
        net.metadiversity.diversity.navigator.db.ub.users.X_UserInfoDescriptor  userInfoDescriptor;
                
        //queries
        OQLQuery      userOql;
        QueryResults  results;

        db = _jdo.getDatabase();

        db.begin();
        writer.println( "Begin transaction" );
       
//        userOql = db.getOQLQuery( "SELECT p FROM net.metadiversity.diversity.navigator.db.ub.users.X_UserInfo p" );
        userOql = db.getOQLQuery( "SELECT p FROM net.metadiversity.diversity.navigator.db.ub.users.X_UserInfo p" );
        results = userOql.execute();
        while ( ( results != null ) && results.hasMore() ) 
        {
            userInfo = ( net.metadiversity.diversity.navigator.db.ub.users.X_UserInfo ) results.next();               
            writer.println( "Person: " + userInfo.getUserName() + " " + userInfo.getUserAbbrev() + " " + userInfo.getAddress() );
        }       
        writer.println( "Transaction checkpoint" );
        // Checkpoint commits all the updates to the database
        // but leaves the transaction (and locks) open
        writer.println( "Commit transaction" );
        db.commit();
        writer.println( "End" );
        db.close();
    }
}
    
