/*
 * This class was automatically generated with 
 * <a href="http://castor.exolab.org">Castor 0.9.3.9+</a>, using an
 * XML Schema.
 * $Id: Identification.java,v 1.1.1.1 2003/03/31 14:39:47 nik Exp $
 */

package net.metadiversity.diversity.navigator.db.ub.collection;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.IOException;
import java.io.Reader;
import java.io.Serializable;
import java.io.Writer;
import java.util.Date;
import org.exolab.castor.xml.*;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ValidationException;
import org.xml.sax.ContentHandler;

/**
 * Identifications of the identification units.
 * 
 * @version $Revision: 1.1.1.1 $ $Date: 2003/03/31 14:39:47 $
**/
public abstract class Identification implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Refers to ID of CollectionUnit (= foreign key).
    **/
    private int _identificationUnitID;

    /**
     * keeps track of state for field: _identificationUnitID
    **/
    private boolean _has_identificationUnitID;

    /**
     * Refers to ID of CollectionSpecimen (= foreign key).
    **/
    private int _collectionSpecimenID;

    /**
     * keeps track of state for field: _collectionSpecimenID
    **/
    private boolean _has_collectionSpecimenID;

    /**
     * Date and time the identification was entered into the
     * system, defines the ordering of identifications.
    **/
    private java.util.Date _identificationSequence;

    /**
     * The day of the identification event.
    **/
    private int _identificationDay;

    /**
     * keeps track of state for field: _identificationDay
    **/
    private boolean _has_identificationDay;

    /**
     * The month of the identification event.
    **/
    private int _identificationMonth;

    /**
     * keeps track of state for field: _identificationMonth
    **/
    private boolean _has_identificationMonth;

    /**
     * The year of the identification event.
    **/
    private int _identificationYear;

    /**
     * keeps track of state for field: _identificationYear
    **/
    private boolean _has_identificationYear;

    /**
     * Verbal or additional identification date information, e.g.
     * "end of summer 1985".
    **/
    private java.lang.String _identificationDateSupplement;

    /**
     * Not taxonomic name e.g. limestone, conifer, hardwood.
    **/
    private java.lang.String _vernacularName;

    /**
     * Valid name of the species with author names of the taxon
     * e.g. "Rosa canina L.".
    **/
    private java.lang.String _taxonomicName;

    /**
     * Unique ID code of the taxon. Refers to the NomID code of
     * TaxonomyName (= foreign key) in the database
     * DiversityTaxonomy.
    **/
    private int _nomID;

    /**
     * keeps track of state for field: _nomID
    **/
    private boolean _has_nomID;

    /**
     * Category of the identification e.g. "determination","
     * confirmation", "absence".
    **/
    private java.lang.String _identificationCategory;

    /**
     * Qualification of the identification e.g. "cf."," aff.", "sp.
     * nov.".
    **/
    private java.lang.String _identificationQualifier;

    /**
     * Defines the valid name for the organism. Can be set only
     * once per organism.
    **/
    private boolean _isLastName;

    /**
     * keeps track of state for field: _isLastName
    **/
    private boolean _has_isLastName;

    /**
     * Source resp. literature used for the determination, e.g.
     * "Schmeil-Fitschen 1995".
    **/
    private java.lang.String _literatureUsed;

    /**
     * The person or institution responsible for the determination.
    **/
    private java.lang.String _responsible;

    /**
     * User definded notes, e.g. the reason for the new
     * determination / change of the name etc.
    **/
    private java.lang.String _notes;

    /**
     * Defines the name under which the collection specimen is
     * published within an exsiccate. Can be set only once per
     * collection specimen.
    **/
    private boolean _isExsiccataTaxon;

    /**
     * keeps track of state for field: _isExsiccataTaxon
    **/
    private boolean _has_isExsiccataTaxon;


      //----------------/
     //- Constructors -/
    //----------------/

    public Identification() {
        super();
    } //-- net.metadiversity.diversity.navigator.db.ub.collection.Identification()


      //-----------/
     //- Methods -/
    //-----------/

    /**
    **/
    public void deleteIdentificationDay()
    {
        this._has_identificationDay= false;
    } //-- void deleteIdentificationDay() 

    /**
    **/
    public void deleteIdentificationMonth()
    {
        this._has_identificationMonth= false;
    } //-- void deleteIdentificationMonth() 

    /**
    **/
    public void deleteIdentificationYear()
    {
        this._has_identificationYear= false;
    } //-- void deleteIdentificationYear() 

    /**
    **/
    public void deleteIsExsiccataTaxon()
    {
        this._has_isExsiccataTaxon= false;
    } //-- void deleteIsExsiccataTaxon() 

    /**
    **/
    public void deleteIsLastName()
    {
        this._has_isLastName= false;
    } //-- void deleteIsLastName() 

    /**
    **/
    public void deleteNomID()
    {
        this._has_nomID= false;
    } //-- void deleteNomID() 

    /**
     * Returns the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: Refers
     * to ID of CollectionSpecimen (= foreign key).
     * 
     * @return the value of field 'collectionSpecimenID'.
    **/
    public int getCollectionSpecimenID()
    {
        return this._collectionSpecimenID;
    } //-- int getCollectionSpecimenID() 

    /**
     * Returns the value of field 'identificationCategory'. The
     * field 'identificationCategory' has the following
     * description: Category of the identification e.g.
     * "determination"," confirmation", "absence".
     * 
     * @return the value of field 'identificationCategory'.
    **/
    public java.lang.String getIdentificationCategory()
    {
        return this._identificationCategory;
    } //-- java.lang.String getIdentificationCategory() 

    /**
     * Returns the value of field 'identificationDateSupplement'.
     * The field 'identificationDateSupplement' has the following
     * description: Verbal or additional identification date
     * information, e.g. "end of summer 1985".
     * 
     * @return the value of field 'identificationDateSupplement'.
    **/
    public java.lang.String getIdentificationDateSupplement()
    {
        return this._identificationDateSupplement;
    } //-- java.lang.String getIdentificationDateSupplement() 

    /**
     * Returns the value of field 'identificationDay'. The field
     * 'identificationDay' has the following description: The day
     * of the identification event.
     * 
     * @return the value of field 'identificationDay'.
    **/
    public int getIdentificationDay()
    {
        return this._identificationDay;
    } //-- int getIdentificationDay() 

    /**
     * Returns the value of field 'identificationMonth'. The field
     * 'identificationMonth' has the following description: The
     * month of the identification event.
     * 
     * @return the value of field 'identificationMonth'.
    **/
    public int getIdentificationMonth()
    {
        return this._identificationMonth;
    } //-- int getIdentificationMonth() 

    /**
     * Returns the value of field 'identificationQualifier'. The
     * field 'identificationQualifier' has the following
     * description: Qualification of the identification e.g.
     * "cf."," aff.", "sp. nov.".
     * 
     * @return the value of field 'identificationQualifier'.
    **/
    public java.lang.String getIdentificationQualifier()
    {
        return this._identificationQualifier;
    } //-- java.lang.String getIdentificationQualifier() 

    /**
     * Returns the value of field 'identificationSequence'. The
     * field 'identificationSequence' has the following
     * description: Date and time the identification was entered
     * into the system, defines the ordering of identifications.
     * 
     * @return the value of field 'identificationSequence'.
    **/
    public java.util.Date getIdentificationSequence()
    {
        return this._identificationSequence;
    } //-- java.util.Date getIdentificationSequence() 

    /**
     * Returns the value of field 'identificationUnitID'. The field
     * 'identificationUnitID' has the following description: Refers
     * to ID of CollectionUnit (= foreign key).
     * 
     * @return the value of field 'identificationUnitID'.
    **/
    public int getIdentificationUnitID()
    {
        return this._identificationUnitID;
    } //-- int getIdentificationUnitID() 

    /**
     * Returns the value of field 'identificationYear'. The field
     * 'identificationYear' has the following description: The year
     * of the identification event.
     * 
     * @return the value of field 'identificationYear'.
    **/
    public int getIdentificationYear()
    {
        return this._identificationYear;
    } //-- int getIdentificationYear() 

    /**
     * Returns the value of field 'isExsiccataTaxon'. The field
     * 'isExsiccataTaxon' has the following description: Defines
     * the name under which the collection specimen is published
     * within an exsiccate. Can be set only once per collection
     * specimen.
     * 
     * @return the value of field 'isExsiccataTaxon'.
    **/
    public boolean getIsExsiccataTaxon()
    {
        return this._isExsiccataTaxon;
    } //-- boolean getIsExsiccataTaxon() 

    /**
     * Returns the value of field 'isLastName'. The field
     * 'isLastName' has the following description: Defines the
     * valid name for the organism. Can be set only once per
     * organism.
     * 
     * @return the value of field 'isLastName'.
    **/
    public boolean getIsLastName()
    {
        return this._isLastName;
    } //-- boolean getIsLastName() 

    /**
     * Returns the value of field 'literatureUsed'. The field
     * 'literatureUsed' has the following description: Source resp.
     * literature used for the determination, e.g.
     * "Schmeil-Fitschen 1995".
     * 
     * @return the value of field 'literatureUsed'.
    **/
    public java.lang.String getLiteratureUsed()
    {
        return this._literatureUsed;
    } //-- java.lang.String getLiteratureUsed() 

    /**
     * Returns the value of field 'nomID'. The field 'nomID' has
     * the following description: Unique ID code of the taxon.
     * Refers to the NomID code of TaxonomyName (= foreign key) in
     * the database DiversityTaxonomy.
     * 
     * @return the value of field 'nomID'.
    **/
    public int getNomID()
    {
        return this._nomID;
    } //-- int getNomID() 

    /**
     * Returns the value of field 'notes'. The field 'notes' has
     * the following description: User definded notes, e.g. the
     * reason for the new determination / change of the name etc.
     * 
     * @return the value of field 'notes'.
    **/
    public java.lang.String getNotes()
    {
        return this._notes;
    } //-- java.lang.String getNotes() 

    /**
     * Returns the value of field 'responsible'. The field
     * 'responsible' has the following description: The person or
     * institution responsible for the determination.
     * 
     * @return the value of field 'responsible'.
    **/
    public java.lang.String getResponsible()
    {
        return this._responsible;
    } //-- java.lang.String getResponsible() 

    /**
     * Returns the value of field 'taxonomicName'. The field
     * 'taxonomicName' has the following description: Valid name of
     * the species with author names of the taxon e.g. "Rosa canina
     * L.".
     * 
     * @return the value of field 'taxonomicName'.
    **/
    public java.lang.String getTaxonomicName()
    {
        return this._taxonomicName;
    } //-- java.lang.String getTaxonomicName() 

    /**
     * Returns the value of field 'vernacularName'. The field
     * 'vernacularName' has the following description: Not
     * taxonomic name e.g. limestone, conifer, hardwood.
     * 
     * @return the value of field 'vernacularName'.
    **/
    public java.lang.String getVernacularName()
    {
        return this._vernacularName;
    } //-- java.lang.String getVernacularName() 

    /**
    **/
    public boolean hasCollectionSpecimenID()
    {
        return this._has_collectionSpecimenID;
    } //-- boolean hasCollectionSpecimenID() 

    /**
    **/
    public boolean hasIdentificationDay()
    {
        return this._has_identificationDay;
    } //-- boolean hasIdentificationDay() 

    /**
    **/
    public boolean hasIdentificationMonth()
    {
        return this._has_identificationMonth;
    } //-- boolean hasIdentificationMonth() 

    /**
    **/
    public boolean hasIdentificationUnitID()
    {
        return this._has_identificationUnitID;
    } //-- boolean hasIdentificationUnitID() 

    /**
    **/
    public boolean hasIdentificationYear()
    {
        return this._has_identificationYear;
    } //-- boolean hasIdentificationYear() 

    /**
    **/
    public boolean hasIsExsiccataTaxon()
    {
        return this._has_isExsiccataTaxon;
    } //-- boolean hasIsExsiccataTaxon() 

    /**
    **/
    public boolean hasIsLastName()
    {
        return this._has_isLastName;
    } //-- boolean hasIsLastName() 

    /**
    **/
    public boolean hasNomID()
    {
        return this._has_nomID;
    } //-- boolean hasNomID() 

    /**
    **/
    public boolean isValid()
    {
        try {
            validate();
        }
        catch (org.exolab.castor.xml.ValidationException vex) {
            return false;
        }
        return true;
    } //-- boolean isValid() 

    /**
     * 
     * 
     * @param out
    **/
    public abstract void marshal(java.io.Writer out)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException;

    /**
     * 
     * 
     * @param handler
    **/
    public abstract void marshal(org.xml.sax.ContentHandler handler)
        throws java.io.IOException, org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException;

    /**
     * Sets the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: Refers
     * to ID of CollectionSpecimen (= foreign key).
     * 
     * @param collectionSpecimenID the value of field
     * 'collectionSpecimenID'.
    **/
    public void setCollectionSpecimenID(int collectionSpecimenID)
    {
        this._collectionSpecimenID = collectionSpecimenID;
        this._has_collectionSpecimenID = true;
    } //-- void setCollectionSpecimenID(int) 

    /**
     * Sets the value of field 'identificationCategory'. The field
     * 'identificationCategory' has the following description:
     * Category of the identification e.g. "determination","
     * confirmation", "absence".
     * 
     * @param identificationCategory the value of field
     * 'identificationCategory'.
    **/
    public void setIdentificationCategory(java.lang.String identificationCategory)
    {
        this._identificationCategory = identificationCategory;
    } //-- void setIdentificationCategory(java.lang.String) 

    /**
     * Sets the value of field 'identificationDateSupplement'. The
     * field 'identificationDateSupplement' has the following
     * description: Verbal or additional identification date
     * information, e.g. "end of summer 1985".
     * 
     * @param identificationDateSupplement the value of field
     * 'identificationDateSupplement'.
    **/
    public void setIdentificationDateSupplement(java.lang.String identificationDateSupplement)
    {
        this._identificationDateSupplement = identificationDateSupplement;
    } //-- void setIdentificationDateSupplement(java.lang.String) 

    /**
     * Sets the value of field 'identificationDay'. The field
     * 'identificationDay' has the following description: The day
     * of the identification event.
     * 
     * @param identificationDay the value of field
     * 'identificationDay'.
    **/
    public void setIdentificationDay(int identificationDay)
    {
        this._identificationDay = identificationDay;
        this._has_identificationDay = true;
    } //-- void setIdentificationDay(int) 

    /**
     * Sets the value of field 'identificationMonth'. The field
     * 'identificationMonth' has the following description: The
     * month of the identification event.
     * 
     * @param identificationMonth the value of field
     * 'identificationMonth'.
    **/
    public void setIdentificationMonth(int identificationMonth)
    {
        this._identificationMonth = identificationMonth;
        this._has_identificationMonth = true;
    } //-- void setIdentificationMonth(int) 

    /**
     * Sets the value of field 'identificationQualifier'. The field
     * 'identificationQualifier' has the following description:
     * Qualification of the identification e.g. "cf."," aff.", "sp.
     * nov.".
     * 
     * @param identificationQualifier the value of field
     * 'identificationQualifier'.
    **/
    public void setIdentificationQualifier(java.lang.String identificationQualifier)
    {
        this._identificationQualifier = identificationQualifier;
    } //-- void setIdentificationQualifier(java.lang.String) 

    /**
     * Sets the value of field 'identificationSequence'. The field
     * 'identificationSequence' has the following description: Date
     * and time the identification was entered into the system,
     * defines the ordering of identifications.
     * 
     * @param identificationSequence the value of field
     * 'identificationSequence'.
    **/
    public void setIdentificationSequence(java.util.Date identificationSequence)
    {
        this._identificationSequence = identificationSequence;
    } //-- void setIdentificationSequence(java.util.Date) 

    /**
     * Sets the value of field 'identificationUnitID'. The field
     * 'identificationUnitID' has the following description: Refers
     * to ID of CollectionUnit (= foreign key).
     * 
     * @param identificationUnitID the value of field
     * 'identificationUnitID'.
    **/
    public void setIdentificationUnitID(int identificationUnitID)
    {
        this._identificationUnitID = identificationUnitID;
        this._has_identificationUnitID = true;
    } //-- void setIdentificationUnitID(int) 

    /**
     * Sets the value of field 'identificationYear'. The field
     * 'identificationYear' has the following description: The year
     * of the identification event.
     * 
     * @param identificationYear the value of field
     * 'identificationYear'.
    **/
    public void setIdentificationYear(int identificationYear)
    {
        this._identificationYear = identificationYear;
        this._has_identificationYear = true;
    } //-- void setIdentificationYear(int) 

    /**
     * Sets the value of field 'isExsiccataTaxon'. The field
     * 'isExsiccataTaxon' has the following description: Defines
     * the name under which the collection specimen is published
     * within an exsiccate. Can be set only once per collection
     * specimen.
     * 
     * @param isExsiccataTaxon the value of field 'isExsiccataTaxon'
    **/
    public void setIsExsiccataTaxon(boolean isExsiccataTaxon)
    {
        this._isExsiccataTaxon = isExsiccataTaxon;
        this._has_isExsiccataTaxon = true;
    } //-- void setIsExsiccataTaxon(boolean) 

    /**
     * Sets the value of field 'isLastName'. The field 'isLastName'
     * has the following description: Defines the valid name for
     * the organism. Can be set only once per organism.
     * 
     * @param isLastName the value of field 'isLastName'.
    **/
    public void setIsLastName(boolean isLastName)
    {
        this._isLastName = isLastName;
        this._has_isLastName = true;
    } //-- void setIsLastName(boolean) 

    /**
     * Sets the value of field 'literatureUsed'. The field
     * 'literatureUsed' has the following description: Source resp.
     * literature used for the determination, e.g.
     * "Schmeil-Fitschen 1995".
     * 
     * @param literatureUsed the value of field 'literatureUsed'.
    **/
    public void setLiteratureUsed(java.lang.String literatureUsed)
    {
        this._literatureUsed = literatureUsed;
    } //-- void setLiteratureUsed(java.lang.String) 

    /**
     * Sets the value of field 'nomID'. The field 'nomID' has the
     * following description: Unique ID code of the taxon. Refers
     * to the NomID code of TaxonomyName (= foreign key) in the
     * database DiversityTaxonomy.
     * 
     * @param nomID the value of field 'nomID'.
    **/
    public void setNomID(int nomID)
    {
        this._nomID = nomID;
        this._has_nomID = true;
    } //-- void setNomID(int) 

    /**
     * Sets the value of field 'notes'. The field 'notes' has the
     * following description: User definded notes, e.g. the reason
     * for the new determination / change of the name etc.
     * 
     * @param notes the value of field 'notes'.
    **/
    public void setNotes(java.lang.String notes)
    {
        this._notes = notes;
    } //-- void setNotes(java.lang.String) 

    /**
     * Sets the value of field 'responsible'. The field
     * 'responsible' has the following description: The person or
     * institution responsible for the determination.
     * 
     * @param responsible the value of field 'responsible'.
    **/
    public void setResponsible(java.lang.String responsible)
    {
        this._responsible = responsible;
    } //-- void setResponsible(java.lang.String) 

    /**
     * Sets the value of field 'taxonomicName'. The field
     * 'taxonomicName' has the following description: Valid name of
     * the species with author names of the taxon e.g. "Rosa canina
     * L.".
     * 
     * @param taxonomicName the value of field 'taxonomicName'.
    **/
    public void setTaxonomicName(java.lang.String taxonomicName)
    {
        this._taxonomicName = taxonomicName;
    } //-- void setTaxonomicName(java.lang.String) 

    /**
     * Sets the value of field 'vernacularName'. The field
     * 'vernacularName' has the following description: Not
     * taxonomic name e.g. limestone, conifer, hardwood.
     * 
     * @param vernacularName the value of field 'vernacularName'.
    **/
    public void setVernacularName(java.lang.String vernacularName)
    {
        this._vernacularName = vernacularName;
    } //-- void setVernacularName(java.lang.String) 

    /**
    **/
    public void validate()
        throws org.exolab.castor.xml.ValidationException
    {
        org.exolab.castor.xml.Validator validator = new org.exolab.castor.xml.Validator();
        validator.validate(this);
    } //-- void validate() 

}
