/*
 * This class was automatically generated with 
 * <a href="http://castor.exolab.org">Castor 0.9.3.9+</a>, using an
 * XML Schema.
 * $Id: IdentificationUnit.java,v 1.1.1.1 2003/03/31 14:39:47 nik Exp $
 */

package net.metadiversity.diversity.navigator.db.ub.collection;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.IOException;
import java.io.Reader;
import java.io.Serializable;
import java.io.Writer;
import org.exolab.castor.xml.*;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ValidationException;
import org.xml.sax.ContentHandler;

/**
 * Organism that is present in or on a collection specimen.
 * 
 * @version $Revision: 1.1.1.1 $ $Date: 2003/03/31 14:39:47 $
**/
public abstract class IdentificationUnit implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * ID of the identification unit (usually an organism that is
     * present on the collection specimen).
    **/
    private int _identificationUnitID;

    /**
     * keeps track of state for field: _identificationUnitID
    **/
    private boolean _has_identificationUnitID;

    /**
     * ID of the collection specimen on which the identification
     * unit is present.
    **/
    private int _collectionSpecimenID;

    /**
     * keeps track of state for field: _collectionSpecimenID
    **/
    private boolean _has_collectionSpecimenID;

    /**
     * Taxonomic group the belongs to e.g. (1) plant, (2) fungus,
     * (3) lichen, (4) animal, (5) bacteria/procaryotic.
    **/
    private int _taxonomicGroup;

    /**
     * keeps track of state for field: _taxonomicGroup
    **/
    private boolean _has_taxonomicGroup;

    /**
     * This organism was only observed by the collector, i.e. it is
     * not present on the specimen.
    **/
    private boolean _onlyObserved;

    /**
     * keeps track of state for field: _onlyObserved
    **/
    private boolean _has_onlyObserved;

    /**
     * If identification unit is type of a taxonomic name:
     * holotype, syntype, etc.
    **/
    private java.lang.String _typeStatus;

    /**
     * Name of the taxonomic name typified by this identification
     * unit.
    **/
    private java.lang.String _typifiedTaxon;

    /**
     * The IdentificationUnitID of the organism or substrate, where
     * this organism is growing on (= foreign key).
    **/
    private int _substrateAssociation;

    /**
     * keeps track of state for field: _substrateAssociation
    **/
    private boolean _has_substrateAssociation;

    /**
     * If a SubstrateAssociation exists: part of the substrate that
     * is affected in the interaction (e.g. 'leaves').
    **/
    private java.lang.String _colonisedPart;

    /**
     * e.g. II, III for spore generations of rusts or seed,
     * seedling etc. for higher plants.
    **/
    private java.lang.String _lifeStage;

    /**
     * Further information on the identification unit or
     * interaction, e.g. symptoms of infection like 'gall'.
    **/
    private java.lang.String _notes;


      //----------------/
     //- Constructors -/
    //----------------/

    public IdentificationUnit() {
        super();
    } //-- net.metadiversity.diversity.navigator.db.ub.collection.IdentificationUnit()


      //-----------/
     //- Methods -/
    //-----------/

    /**
    **/
    public void deleteSubstrateAssociation()
    {
        this._has_substrateAssociation= false;
    } //-- void deleteSubstrateAssociation() 

    /**
     * Returns the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: ID of
     * the collection specimen on which the identification unit is
     * present.
     * 
     * @return the value of field 'collectionSpecimenID'.
    **/
    public int getCollectionSpecimenID()
    {
        return this._collectionSpecimenID;
    } //-- int getCollectionSpecimenID() 

    /**
     * Returns the value of field 'colonisedPart'. The field
     * 'colonisedPart' has the following description: If a
     * SubstrateAssociation exists: part of the substrate that is
     * affected in the interaction (e.g. 'leaves').
     * 
     * @return the value of field 'colonisedPart'.
    **/
    public java.lang.String getColonisedPart()
    {
        return this._colonisedPart;
    } //-- java.lang.String getColonisedPart() 

    /**
     * Returns the value of field 'identificationUnitID'. The field
     * 'identificationUnitID' has the following description: ID of
     * the identification unit (usually an organism that is present
     * on the collection specimen).
     * 
     * @return the value of field 'identificationUnitID'.
    **/
    public int getIdentificationUnitID()
    {
        return this._identificationUnitID;
    } //-- int getIdentificationUnitID() 

    /**
     * Returns the value of field 'lifeStage'. The field
     * 'lifeStage' has the following description: e.g. II, III for
     * spore generations of rusts or seed, seedling etc. for higher
     * plants.
     * 
     * @return the value of field 'lifeStage'.
    **/
    public java.lang.String getLifeStage()
    {
        return this._lifeStage;
    } //-- java.lang.String getLifeStage() 

    /**
     * Returns the value of field 'notes'. The field 'notes' has
     * the following description: Further information on the
     * identification unit or interaction, e.g. symptoms of
     * infection like 'gall'.
     * 
     * @return the value of field 'notes'.
    **/
    public java.lang.String getNotes()
    {
        return this._notes;
    } //-- java.lang.String getNotes() 

    /**
     * Returns the value of field 'onlyObserved'. The field
     * 'onlyObserved' has the following description: This organism
     * was only observed by the collector, i.e. it is not present
     * on the specimen.
     * 
     * @return the value of field 'onlyObserved'.
    **/
    public boolean getOnlyObserved()
    {
        return this._onlyObserved;
    } //-- boolean getOnlyObserved() 

    /**
     * Returns the value of field 'substrateAssociation'. The field
     * 'substrateAssociation' has the following description: The
     * IdentificationUnitID of the organism or substrate, where
     * this organism is growing on (= foreign key).
     * 
     * @return the value of field 'substrateAssociation'.
    **/
    public int getSubstrateAssociation()
    {
        return this._substrateAssociation;
    } //-- int getSubstrateAssociation() 

    /**
     * Returns the value of field 'taxonomicGroup'. The field
     * 'taxonomicGroup' has the following description: Taxonomic
     * group the belongs to e.g. (1) plant, (2) fungus, (3) lichen,
     * (4) animal, (5) bacteria/procaryotic.
     * 
     * @return the value of field 'taxonomicGroup'.
    **/
    public int getTaxonomicGroup()
    {
        return this._taxonomicGroup;
    } //-- int getTaxonomicGroup() 

    /**
     * Returns the value of field 'typeStatus'. The field
     * 'typeStatus' has the following description: If
     * identification unit is type of a taxonomic name: holotype,
     * syntype, etc.
     * 
     * @return the value of field 'typeStatus'.
    **/
    public java.lang.String getTypeStatus()
    {
        return this._typeStatus;
    } //-- java.lang.String getTypeStatus() 

    /**
     * Returns the value of field 'typifiedTaxon'. The field
     * 'typifiedTaxon' has the following description: Name of the
     * taxonomic name typified by this identification unit.
     * 
     * @return the value of field 'typifiedTaxon'.
    **/
    public java.lang.String getTypifiedTaxon()
    {
        return this._typifiedTaxon;
    } //-- java.lang.String getTypifiedTaxon() 

    /**
    **/
    public boolean hasCollectionSpecimenID()
    {
        return this._has_collectionSpecimenID;
    } //-- boolean hasCollectionSpecimenID() 

    /**
    **/
    public boolean hasIdentificationUnitID()
    {
        return this._has_identificationUnitID;
    } //-- boolean hasIdentificationUnitID() 

    /**
    **/
    public boolean hasOnlyObserved()
    {
        return this._has_onlyObserved;
    } //-- boolean hasOnlyObserved() 

    /**
    **/
    public boolean hasSubstrateAssociation()
    {
        return this._has_substrateAssociation;
    } //-- boolean hasSubstrateAssociation() 

    /**
    **/
    public boolean hasTaxonomicGroup()
    {
        return this._has_taxonomicGroup;
    } //-- boolean hasTaxonomicGroup() 

    /**
    **/
    public boolean isValid()
    {
        try {
            validate();
        }
        catch (org.exolab.castor.xml.ValidationException vex) {
            return false;
        }
        return true;
    } //-- boolean isValid() 

    /**
     * 
     * 
     * @param out
    **/
    public abstract void marshal(java.io.Writer out)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException;

    /**
     * 
     * 
     * @param handler
    **/
    public abstract void marshal(org.xml.sax.ContentHandler handler)
        throws java.io.IOException, org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException;

    /**
     * Sets the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: ID of
     * the collection specimen on which the identification unit is
     * present.
     * 
     * @param collectionSpecimenID the value of field
     * 'collectionSpecimenID'.
    **/
    public void setCollectionSpecimenID(int collectionSpecimenID)
    {
        this._collectionSpecimenID = collectionSpecimenID;
        this._has_collectionSpecimenID = true;
    } //-- void setCollectionSpecimenID(int) 

    /**
     * Sets the value of field 'colonisedPart'. The field
     * 'colonisedPart' has the following description: If a
     * SubstrateAssociation exists: part of the substrate that is
     * affected in the interaction (e.g. 'leaves').
     * 
     * @param colonisedPart the value of field 'colonisedPart'.
    **/
    public void setColonisedPart(java.lang.String colonisedPart)
    {
        this._colonisedPart = colonisedPart;
    } //-- void setColonisedPart(java.lang.String) 

    /**
     * Sets the value of field 'identificationUnitID'. The field
     * 'identificationUnitID' has the following description: ID of
     * the identification unit (usually an organism that is present
     * on the collection specimen).
     * 
     * @param identificationUnitID the value of field
     * 'identificationUnitID'.
    **/
    public void setIdentificationUnitID(int identificationUnitID)
    {
        this._identificationUnitID = identificationUnitID;
        this._has_identificationUnitID = true;
    } //-- void setIdentificationUnitID(int) 

    /**
     * Sets the value of field 'lifeStage'. The field 'lifeStage'
     * has the following description: e.g. II, III for spore
     * generations of rusts or seed, seedling etc. for higher
     * plants.
     * 
     * @param lifeStage the value of field 'lifeStage'.
    **/
    public void setLifeStage(java.lang.String lifeStage)
    {
        this._lifeStage = lifeStage;
    } //-- void setLifeStage(java.lang.String) 

    /**
     * Sets the value of field 'notes'. The field 'notes' has the
     * following description: Further information on the
     * identification unit or interaction, e.g. symptoms of
     * infection like 'gall'.
     * 
     * @param notes the value of field 'notes'.
    **/
    public void setNotes(java.lang.String notes)
    {
        this._notes = notes;
    } //-- void setNotes(java.lang.String) 

    /**
     * Sets the value of field 'onlyObserved'. The field
     * 'onlyObserved' has the following description: This organism
     * was only observed by the collector, i.e. it is not present
     * on the specimen.
     * 
     * @param onlyObserved the value of field 'onlyObserved'.
    **/
    public void setOnlyObserved(boolean onlyObserved)
    {
        this._onlyObserved = onlyObserved;
        this._has_onlyObserved = true;
    } //-- void setOnlyObserved(boolean) 

    /**
     * Sets the value of field 'substrateAssociation'. The field
     * 'substrateAssociation' has the following description: The
     * IdentificationUnitID of the organism or substrate, where
     * this organism is growing on (= foreign key).
     * 
     * @param substrateAssociation the value of field
     * 'substrateAssociation'.
    **/
    public void setSubstrateAssociation(int substrateAssociation)
    {
        this._substrateAssociation = substrateAssociation;
        this._has_substrateAssociation = true;
    } //-- void setSubstrateAssociation(int) 

    /**
     * Sets the value of field 'taxonomicGroup'. The field
     * 'taxonomicGroup' has the following description: Taxonomic
     * group the belongs to e.g. (1) plant, (2) fungus, (3) lichen,
     * (4) animal, (5) bacteria/procaryotic.
     * 
     * @param taxonomicGroup the value of field 'taxonomicGroup'.
    **/
    public void setTaxonomicGroup(int taxonomicGroup)
    {
        this._taxonomicGroup = taxonomicGroup;
        this._has_taxonomicGroup = true;
    } //-- void setTaxonomicGroup(int) 

    /**
     * Sets the value of field 'typeStatus'. The field 'typeStatus'
     * has the following description: If identification unit is
     * type of a taxonomic name: holotype, syntype, etc.
     * 
     * @param typeStatus the value of field 'typeStatus'.
    **/
    public void setTypeStatus(java.lang.String typeStatus)
    {
        this._typeStatus = typeStatus;
    } //-- void setTypeStatus(java.lang.String) 

    /**
     * Sets the value of field 'typifiedTaxon'. The field
     * 'typifiedTaxon' has the following description: Name of the
     * taxonomic name typified by this identification unit.
     * 
     * @param typifiedTaxon the value of field 'typifiedTaxon'.
    **/
    public void setTypifiedTaxon(java.lang.String typifiedTaxon)
    {
        this._typifiedTaxon = typifiedTaxon;
    } //-- void setTypifiedTaxon(java.lang.String) 

    /**
    **/
    public void validate()
        throws org.exolab.castor.xml.ValidationException
    {
        org.exolab.castor.xml.Validator validator = new org.exolab.castor.xml.Validator();
        validator.validate(this);
    } //-- void validate() 

}
