/*
 * This class was automatically generated with 
 * <a href="http://castor.exolab.org">Castor 0.9.3.9+</a>, using an
 * XML Schema.
 * $Id: LocalisationSystem.java,v 1.1.1.1 2003/03/31 14:39:47 nik Exp $
 */

package net.metadiversity.diversity.navigator.db.ub.collection;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.IOException;
import java.io.Reader;
import java.io.Serializable;
import java.io.Writer;
import org.exolab.castor.xml.*;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ValidationException;
import org.xml.sax.ContentHandler;

/**
 * Localisation system used for the determination of the
 * geographical data.
 * 
 * @version $Revision: 1.1.1.1 $ $Date: 2003/03/31 14:39:47 $
**/
public abstract class LocalisationSystem implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Unique reference ID for localisation system (= primary key).
    **/
    private int _localisationSystemID;

    /**
     * keeps track of state for field: _localisationSystemID
    **/
    private boolean _has_localisationSystemID;

    /**
     * Name of the system used for the determination of the place
     * of the collection, e. g. Gauss-Krger, MTB, GIS.
    **/
    private java.lang.String _localisationSystemName;

    /**
     * Refers to ID of CoordinateSystem (= foreign key).
    **/
    private int _localisationSystemTypeID;

    /**
     * keeps track of state for field: _localisationSystemTypeID
    **/
    private boolean _has_localisationSystemTypeID;

    /**
     * User interface definition: locked status, label captions,
     * etc. displayed in the form CollectionLocality.
    **/
    private java.lang.String _interfaceDefinitions;

    /**
     * Despription of the localisation method.
    **/
    private java.lang.String _description;

    /**
     * Unit used within the localisation system, e.g. m, miles etc.
    **/
    private java.lang.String _measurementUnit;

    /**
     * The accuracy of values that can be reached with this method.
    **/
    private java.lang.String _accuracyOfLocalisation;

    /**
     * Method for parsing the values typed in the fields
     * [Location1, -2] in table [CollectionGeography]
    **/
    private java.lang.String _parsingMethod;

    /**
     * Specifies if this item is enabled to be used within the
     * database.
    **/
    private boolean _enabled;

    /**
     * keeps track of state for field: _enabled
    **/
    private boolean _has_enabled;


      //----------------/
     //- Constructors -/
    //----------------/

    public LocalisationSystem() {
        super();
    } //-- net.metadiversity.diversity.navigator.db.ub.collection.LocalisationSystem()


      //-----------/
     //- Methods -/
    //-----------/

    /**
    **/
    public void deleteEnabled()
    {
        this._has_enabled= false;
    } //-- void deleteEnabled() 

    /**
    **/
    public void deleteLocalisationSystemTypeID()
    {
        this._has_localisationSystemTypeID= false;
    } //-- void deleteLocalisationSystemTypeID() 

    /**
     * Returns the value of field 'accuracyOfLocalisation'. The
     * field 'accuracyOfLocalisation' has the following
     * description: The accuracy of values that can be reached with
     * this method.
     * 
     * @return the value of field 'accuracyOfLocalisation'.
    **/
    public java.lang.String getAccuracyOfLocalisation()
    {
        return this._accuracyOfLocalisation;
    } //-- java.lang.String getAccuracyOfLocalisation() 

    /**
     * Returns the value of field 'description'. The field
     * 'description' has the following description: Despription of
     * the localisation method.
     * 
     * @return the value of field 'description'.
    **/
    public java.lang.String getDescription()
    {
        return this._description;
    } //-- java.lang.String getDescription() 

    /**
     * Returns the value of field 'enabled'. The field 'enabled'
     * has the following description: Specifies if this item is
     * enabled to be used within the database.
     * 
     * @return the value of field 'enabled'.
    **/
    public boolean getEnabled()
    {
        return this._enabled;
    } //-- boolean getEnabled() 

    /**
     * Returns the value of field 'interfaceDefinitions'. The field
     * 'interfaceDefinitions' has the following description: User
     * interface definition: locked status, label captions, etc.
     * displayed in the form CollectionLocality.
     * 
     * @return the value of field 'interfaceDefinitions'.
    **/
    public java.lang.String getInterfaceDefinitions()
    {
        return this._interfaceDefinitions;
    } //-- java.lang.String getInterfaceDefinitions() 

    /**
     * Returns the value of field 'localisationSystemID'. The field
     * 'localisationSystemID' has the following description: Unique
     * reference ID for localisation system (= primary key).
     * 
     * @return the value of field 'localisationSystemID'.
    **/
    public int getLocalisationSystemID()
    {
        return this._localisationSystemID;
    } //-- int getLocalisationSystemID() 

    /**
     * Returns the value of field 'localisationSystemName'. The
     * field 'localisationSystemName' has the following
     * description: Name of the system used for the determination
     * of the place of the collection, e. g. Gauss-Krger, MTB,
     * GIS.
     * 
     * @return the value of field 'localisationSystemName'.
    **/
    public java.lang.String getLocalisationSystemName()
    {
        return this._localisationSystemName;
    } //-- java.lang.String getLocalisationSystemName() 

    /**
     * Returns the value of field 'localisationSystemTypeID'. The
     * field 'localisationSystemTypeID' has the following
     * description: Refers to ID of CoordinateSystem (= foreign
     * key).
     * 
     * @return the value of field 'localisationSystemTypeID'.
    **/
    public int getLocalisationSystemTypeID()
    {
        return this._localisationSystemTypeID;
    } //-- int getLocalisationSystemTypeID() 

    /**
     * Returns the value of field 'measurementUnit'. The field
     * 'measurementUnit' has the following description: Unit used
     * within the localisation system, e.g. m, miles etc.
     * 
     * @return the value of field 'measurementUnit'.
    **/
    public java.lang.String getMeasurementUnit()
    {
        return this._measurementUnit;
    } //-- java.lang.String getMeasurementUnit() 

    /**
     * Returns the value of field 'parsingMethod'. The field
     * 'parsingMethod' has the following description: Method for
     * parsing the values typed in the fields [Location1, -2] in
     * table [CollectionGeography]
     * 
     * @return the value of field 'parsingMethod'.
    **/
    public java.lang.String getParsingMethod()
    {
        return this._parsingMethod;
    } //-- java.lang.String getParsingMethod() 

    /**
    **/
    public boolean hasEnabled()
    {
        return this._has_enabled;
    } //-- boolean hasEnabled() 

    /**
    **/
    public boolean hasLocalisationSystemID()
    {
        return this._has_localisationSystemID;
    } //-- boolean hasLocalisationSystemID() 

    /**
    **/
    public boolean hasLocalisationSystemTypeID()
    {
        return this._has_localisationSystemTypeID;
    } //-- boolean hasLocalisationSystemTypeID() 

    /**
    **/
    public boolean isValid()
    {
        try {
            validate();
        }
        catch (org.exolab.castor.xml.ValidationException vex) {
            return false;
        }
        return true;
    } //-- boolean isValid() 

    /**
     * 
     * 
     * @param out
    **/
    public abstract void marshal(java.io.Writer out)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException;

    /**
     * 
     * 
     * @param handler
    **/
    public abstract void marshal(org.xml.sax.ContentHandler handler)
        throws java.io.IOException, org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException;

    /**
     * Sets the value of field 'accuracyOfLocalisation'. The field
     * 'accuracyOfLocalisation' has the following description: The
     * accuracy of values that can be reached with this method.
     * 
     * @param accuracyOfLocalisation the value of field
     * 'accuracyOfLocalisation'.
    **/
    public void setAccuracyOfLocalisation(java.lang.String accuracyOfLocalisation)
    {
        this._accuracyOfLocalisation = accuracyOfLocalisation;
    } //-- void setAccuracyOfLocalisation(java.lang.String) 

    /**
     * Sets the value of field 'description'. The field
     * 'description' has the following description: Despription of
     * the localisation method.
     * 
     * @param description the value of field 'description'.
    **/
    public void setDescription(java.lang.String description)
    {
        this._description = description;
    } //-- void setDescription(java.lang.String) 

    /**
     * Sets the value of field 'enabled'. The field 'enabled' has
     * the following description: Specifies if this item is enabled
     * to be used within the database.
     * 
     * @param enabled the value of field 'enabled'.
    **/
    public void setEnabled(boolean enabled)
    {
        this._enabled = enabled;
        this._has_enabled = true;
    } //-- void setEnabled(boolean) 

    /**
     * Sets the value of field 'interfaceDefinitions'. The field
     * 'interfaceDefinitions' has the following description: User
     * interface definition: locked status, label captions, etc.
     * displayed in the form CollectionLocality.
     * 
     * @param interfaceDefinitions the value of field
     * 'interfaceDefinitions'.
    **/
    public void setInterfaceDefinitions(java.lang.String interfaceDefinitions)
    {
        this._interfaceDefinitions = interfaceDefinitions;
    } //-- void setInterfaceDefinitions(java.lang.String) 

    /**
     * Sets the value of field 'localisationSystemID'. The field
     * 'localisationSystemID' has the following description: Unique
     * reference ID for localisation system (= primary key).
     * 
     * @param localisationSystemID the value of field
     * 'localisationSystemID'.
    **/
    public void setLocalisationSystemID(int localisationSystemID)
    {
        this._localisationSystemID = localisationSystemID;
        this._has_localisationSystemID = true;
    } //-- void setLocalisationSystemID(int) 

    /**
     * Sets the value of field 'localisationSystemName'. The field
     * 'localisationSystemName' has the following description: Name
     * of the system used for the determination of the place of the
     * collection, e. g. Gauss-Krger, MTB, GIS.
     * 
     * @param localisationSystemName the value of field
     * 'localisationSystemName'.
    **/
    public void setLocalisationSystemName(java.lang.String localisationSystemName)
    {
        this._localisationSystemName = localisationSystemName;
    } //-- void setLocalisationSystemName(java.lang.String) 

    /**
     * Sets the value of field 'localisationSystemTypeID'. The
     * field 'localisationSystemTypeID' has the following
     * description: Refers to ID of CoordinateSystem (= foreign
     * key).
     * 
     * @param localisationSystemTypeID the value of field
     * 'localisationSystemTypeID'.
    **/
    public void setLocalisationSystemTypeID(int localisationSystemTypeID)
    {
        this._localisationSystemTypeID = localisationSystemTypeID;
        this._has_localisationSystemTypeID = true;
    } //-- void setLocalisationSystemTypeID(int) 

    /**
     * Sets the value of field 'measurementUnit'. The field
     * 'measurementUnit' has the following description: Unit used
     * within the localisation system, e.g. m, miles etc.
     * 
     * @param measurementUnit the value of field 'measurementUnit'.
    **/
    public void setMeasurementUnit(java.lang.String measurementUnit)
    {
        this._measurementUnit = measurementUnit;
    } //-- void setMeasurementUnit(java.lang.String) 

    /**
     * Sets the value of field 'parsingMethod'. The field
     * 'parsingMethod' has the following description: Method for
     * parsing the values typed in the fields [Location1, -2] in
     * table [CollectionGeography]
     * 
     * @param parsingMethod the value of field 'parsingMethod'.
    **/
    public void setParsingMethod(java.lang.String parsingMethod)
    {
        this._parsingMethod = parsingMethod;
    } //-- void setParsingMethod(java.lang.String) 

    /**
    **/
    public void validate()
        throws org.exolab.castor.xml.ValidationException
    {
        org.exolab.castor.xml.Validator validator = new org.exolab.castor.xml.Validator();
        validator.validate(this);
    } //-- void validate() 

}
