/*
 * This class was automatically generated with 
 * <a href="http://www.castor.org">Castor 0.9.5.2</a>, using an XML
 * Schema.
 * $Id: CollectionImage.java,v 1.1 2003/12/11 14:48:57 didi Exp $
 */

package net.metadiversity.diversity.navigator.db.ub_094.collection;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.IOException;
import java.io.Reader;
import java.io.Serializable;
import java.io.Writer;
import java.util.Date;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.xml.Unmarshaller;
import org.exolab.castor.xml.ValidationException;
import org.xml.sax.ContentHandler;

/**
 * Images of the collection specimen.
 * 
 * @version $Revision: 1.1 $ $Date: 2003/12/11 14:48:57 $
 */
public class CollectionImage implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Refers to the ID of CollectionSpecimen (= Foreign key).
     */
    private int _collectionSpecimenID;

    /**
     * keeps track of state for field: _collectionSpecimenID
     */
    private boolean _has_collectionSpecimenID;

    /**
     * The file name and path of the image relative to the main
     * folder for all images e.g.
     * '/Fungi/Ascomycetes/Erysiphales/ErysipheGraminis.jpg'
     * (within the globally defined server/path combination).
     */
    private java.lang.String _imagePath;

    /**
     * If image refers to only on out of several identification
     * units for a specimen, refers to the ID of an
     * IdentificationUnit for a CollectionSpecimen (= foreign key).
     */
    private int _identificationUnitID;

    /**
     * keeps track of state for field: _identificationUnitID
     */
    private boolean _has_identificationUnitID;

    /**
     * The caption of the image.
     */
    private java.lang.String _imageCaption;

    /**
     * Optional: Author(s), photographer, director, etc. Person(s)
     * or institution(s) responsible for the creation of the
     * abstract resource item (not of the instance, e.g. a scan of
     * an image). [DC11!]
     */
    private java.lang.String _creator;

    /**
     * Creation date (optionally also time) of the original
     * resource. For digitized resources this should refer to the
     * original creation (of the abstract item, e.g. when picture
     * was drawn or photographed), not the digitization process.
     */
    private java.util.Date _creationDate;

    /**
     * Optional: additional information regarding the creation
     * process, e.g. image lens, scale, exposure time, etc.
     */
    private java.lang.String _creationMetadata;

    /**
     * Optional: Information about rights (copyright, intellectual
     * property) held in and over the resource. Enter esp. name of
     * person or institution holding the copyright. Leave empty if
     * unknown or if rights are globally described in resource
     * collection. [DC11!]
     */
    private java.lang.String _rights;

    /**
     * Type of the image, e.g. label.
     */
    private java.lang.String _imageType;


      //----------------/
     //- Constructors -/
    //----------------/

    public CollectionImage() {
        super();
    } //-- net.metadiversity.diversity.navigator.db.ub_094.collection.CollectionImage()


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method deleteIdentificationUnitID
     */
    public void deleteIdentificationUnitID()
    {
        this._has_identificationUnitID= false;
    } //-- void deleteIdentificationUnitID() 

    /**
     * Returns the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: Refers
     * to the ID of CollectionSpecimen (= Foreign key).
     * 
     * @return the value of field 'collectionSpecimenID'.
     */
    public int getCollectionSpecimenID()
    {
        return this._collectionSpecimenID;
    } //-- int getCollectionSpecimenID() 

    /**
     * Returns the value of field 'creationDate'. The field
     * 'creationDate' has the following description: Creation date
     * (optionally also time) of the original resource. For
     * digitized resources this should refer to the original
     * creation (of the abstract item, e.g. when picture was drawn
     * or photographed), not the digitization process.
     * 
     * @return the value of field 'creationDate'.
     */
    public java.util.Date getCreationDate()
    {
        return this._creationDate;
    } //-- java.util.Date getCreationDate() 

    /**
     * Returns the value of field 'creationMetadata'. The field
     * 'creationMetadata' has the following description: Optional:
     * additional information regarding the creation process, e.g.
     * image lens, scale, exposure time, etc.
     * 
     * @return the value of field 'creationMetadata'.
     */
    public java.lang.String getCreationMetadata()
    {
        return this._creationMetadata;
    } //-- java.lang.String getCreationMetadata() 

    /**
     * Returns the value of field 'creator'. The field 'creator'
     * has the following description: Optional: Author(s),
     * photographer, director, etc. Person(s) or institution(s)
     * responsible for the creation of the abstract resource item
     * (not of the instance, e.g. a scan of an image). [DC11!]
     * 
     * @return the value of field 'creator'.
     */
    public java.lang.String getCreator()
    {
        return this._creator;
    } //-- java.lang.String getCreator() 

    /**
     * Returns the value of field 'identificationUnitID'. The field
     * 'identificationUnitID' has the following description: If
     * image refers to only on out of several identification units
     * for a specimen, refers to the ID of an IdentificationUnit
     * for a CollectionSpecimen (= foreign key).
     * 
     * @return the value of field 'identificationUnitID'.
     */
    public int getIdentificationUnitID()
    {
        return this._identificationUnitID;
    } //-- int getIdentificationUnitID() 

    /**
     * Returns the value of field 'imageCaption'. The field
     * 'imageCaption' has the following description: The caption of
     * the image.
     * 
     * @return the value of field 'imageCaption'.
     */
    public java.lang.String getImageCaption()
    {
        return this._imageCaption;
    } //-- java.lang.String getImageCaption() 

    /**
     * Returns the value of field 'imagePath'. The field
     * 'imagePath' has the following description: The file name and
     * path of the image relative to the main folder for all images
     * e.g. '/Fungi/Ascomycetes/Erysiphales/ErysipheGraminis.jpg'
     * (within the globally defined server/path combination).
     * 
     * @return the value of field 'imagePath'.
     */
    public java.lang.String getImagePath()
    {
        return this._imagePath;
    } //-- java.lang.String getImagePath() 

    /**
     * Returns the value of field 'imageType'. The field
     * 'imageType' has the following description: Type of the
     * image, e.g. label.
     * 
     * @return the value of field 'imageType'.
     */
    public java.lang.String getImageType()
    {
        return this._imageType;
    } //-- java.lang.String getImageType() 

    /**
     * Returns the value of field 'rights'. The field 'rights' has
     * the following description: Optional: Information about
     * rights (copyright, intellectual property) held in and over
     * the resource. Enter esp. name of person or institution
     * holding the copyright. Leave empty if unknown or if rights
     * are globally described in resource collection. [DC11!]
     * 
     * @return the value of field 'rights'.
     */
    public java.lang.String getRights()
    {
        return this._rights;
    } //-- java.lang.String getRights() 

    /**
     * Method hasCollectionSpecimenID
     */
    public boolean hasCollectionSpecimenID()
    {
        return this._has_collectionSpecimenID;
    } //-- boolean hasCollectionSpecimenID() 

    /**
     * Method hasIdentificationUnitID
     */
    public boolean hasIdentificationUnitID()
    {
        return this._has_identificationUnitID;
    } //-- boolean hasIdentificationUnitID() 

    /**
     * Method isValid
     */
    public boolean isValid()
    {
        try {
            validate();
        }
        catch (org.exolab.castor.xml.ValidationException vex) {
            return false;
        }
        return true;
    } //-- boolean isValid() 

    /**
     * Method marshal
     * 
     * @param out
     */
    public void marshal(java.io.Writer out)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, out);
    } //-- void marshal(java.io.Writer) 

    /**
     * Method marshal
     * 
     * @param handler
     */
    public void marshal(org.xml.sax.ContentHandler handler)
        throws java.io.IOException, org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, handler);
    } //-- void marshal(org.xml.sax.ContentHandler) 

    /**
     * Sets the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: Refers
     * to the ID of CollectionSpecimen (= Foreign key).
     * 
     * @param collectionSpecimenID the value of field
     * 'collectionSpecimenID'.
     */
    public void setCollectionSpecimenID(int collectionSpecimenID)
    {
        this._collectionSpecimenID = collectionSpecimenID;
        this._has_collectionSpecimenID = true;
    } //-- void setCollectionSpecimenID(int) 

    /**
     * Sets the value of field 'creationDate'. The field
     * 'creationDate' has the following description: Creation date
     * (optionally also time) of the original resource. For
     * digitized resources this should refer to the original
     * creation (of the abstract item, e.g. when picture was drawn
     * or photographed), not the digitization process.
     * 
     * @param creationDate the value of field 'creationDate'.
     */
    public void setCreationDate(java.util.Date creationDate)
    {
        this._creationDate = creationDate;
    } //-- void setCreationDate(java.util.Date) 

    /**
     * Sets the value of field 'creationMetadata'. The field
     * 'creationMetadata' has the following description: Optional:
     * additional information regarding the creation process, e.g.
     * image lens, scale, exposure time, etc.
     * 
     * @param creationMetadata the value of field 'creationMetadata'
     */
    public void setCreationMetadata(java.lang.String creationMetadata)
    {
        this._creationMetadata = creationMetadata;
    } //-- void setCreationMetadata(java.lang.String) 

    /**
     * Sets the value of field 'creator'. The field 'creator' has
     * the following description: Optional: Author(s),
     * photographer, director, etc. Person(s) or institution(s)
     * responsible for the creation of the abstract resource item
     * (not of the instance, e.g. a scan of an image). [DC11!]
     * 
     * @param creator the value of field 'creator'.
     */
    public void setCreator(java.lang.String creator)
    {
        this._creator = creator;
    } //-- void setCreator(java.lang.String) 

    /**
     * Sets the value of field 'identificationUnitID'. The field
     * 'identificationUnitID' has the following description: If
     * image refers to only on out of several identification units
     * for a specimen, refers to the ID of an IdentificationUnit
     * for a CollectionSpecimen (= foreign key).
     * 
     * @param identificationUnitID the value of field
     * 'identificationUnitID'.
     */
    public void setIdentificationUnitID(int identificationUnitID)
    {
        this._identificationUnitID = identificationUnitID;
        this._has_identificationUnitID = true;
    } //-- void setIdentificationUnitID(int) 

    /**
     * Sets the value of field 'imageCaption'. The field
     * 'imageCaption' has the following description: The caption of
     * the image.
     * 
     * @param imageCaption the value of field 'imageCaption'.
     */
    public void setImageCaption(java.lang.String imageCaption)
    {
        this._imageCaption = imageCaption;
    } //-- void setImageCaption(java.lang.String) 

    /**
     * Sets the value of field 'imagePath'. The field 'imagePath'
     * has the following description: The file name and path of the
     * image relative to the main folder for all images e.g.
     * '/Fungi/Ascomycetes/Erysiphales/ErysipheGraminis.jpg'
     * (within the globally defined server/path combination).
     * 
     * @param imagePath the value of field 'imagePath'.
     */
    public void setImagePath(java.lang.String imagePath)
    {
        this._imagePath = imagePath;
    } //-- void setImagePath(java.lang.String) 

    /**
     * Sets the value of field 'imageType'. The field 'imageType'
     * has the following description: Type of the image, e.g.
     * label.
     * 
     * @param imageType the value of field 'imageType'.
     */
    public void setImageType(java.lang.String imageType)
    {
        this._imageType = imageType;
    } //-- void setImageType(java.lang.String) 

    /**
     * Sets the value of field 'rights'. The field 'rights' has the
     * following description: Optional: Information about rights
     * (copyright, intellectual property) held in and over the
     * resource. Enter esp. name of person or institution holding
     * the copyright. Leave empty if unknown or if rights are
     * globally described in resource collection. [DC11!]
     * 
     * @param rights the value of field 'rights'.
     */
    public void setRights(java.lang.String rights)
    {
        this._rights = rights;
    } //-- void setRights(java.lang.String) 

    /**
     * Method unmarshal
     * 
     * @param reader
     */
    public static java.lang.Object unmarshal(java.io.Reader reader)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        return (net.metadiversity.diversity.navigator.db.ub_094.collection.CollectionImage) Unmarshaller.unmarshal(net.metadiversity.diversity.navigator.db.ub_094.collection.CollectionImage.class, reader);
    } //-- java.lang.Object unmarshal(java.io.Reader) 

    /**
     * Method validate
     */
    public void validate()
        throws org.exolab.castor.xml.ValidationException
    {
        org.exolab.castor.xml.Validator validator = new org.exolab.castor.xml.Validator();
        validator.validate(this);
    } //-- void validate() 

}
