/*
 * This class was automatically generated with 
 * <a href="http://www.castor.org">Castor 0.9.5.2</a>, using an XML
 * Schema.
 * $Id: CollectionSpecimen.java,v 1.1 2003/12/11 14:48:57 didi Exp $
 */

package net.metadiversity.diversity.navigator.db.ub_094.collection;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.IOException;
import java.io.Reader;
import java.io.Serializable;
import java.io.Writer;
import java.util.Date;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.xml.Unmarshaller;
import org.exolab.castor.xml.ValidationException;
import org.xml.sax.ContentHandler;

/**
 * A specimen (= collection unit) within a collection. This is the
 * central object of the DiversityCollection database.
 * 
 * @version $Revision: 1.1 $ $Date: 2003/12/11 14:48:57 $
 */
public class CollectionSpecimen implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Unique reference ID for the collection specimen record
     * (primary key).
     */
    private int _collectionSpecimenID;

    /**
     * keeps track of state for field: _collectionSpecimenID
     */
    private boolean _has_collectionSpecimenID;

    /**
     * Date of the collection event (calculated value based on
     * CollectionDay, Month, and Year; if day or month are missing
     * they are assumed to be '1' for the purpose of the date
     * calculation).
     */
    private java.util.Date _collectionDateCache;

    /**
     * The day of the date of the collection event.
     */
    private int _collectionDay;

    /**
     * keeps track of state for field: _collectionDay
     */
    private boolean _has_collectionDay;

    /**
     * The month of the date of the collection event.
     */
    private int _collectionMonth;

    /**
     * keeps track of state for field: _collectionMonth
     */
    private boolean _has_collectionMonth;

    /**
     * The year of the collection event. The year may be left empty
     * if only the day or month are known.
     */
    private short _collectionYear;

    /**
     * keeps track of state for field: _collectionYear
     */
    private boolean _has_collectionYear;

    /**
     * Verbal or additional collection date information, e.g. 'end
     * of summer 1985', 'first quarter', '1888-1892'.
     */
    private java.lang.String _collectionDateSupplement;

    /**
     * Category of the date of the identification e.g. "system",
     * "estimated" (= foreign key, see in table
     * xColl_DateCategory_Enum).
     */
    private java.lang.String _collectionDateCategory;

    /**
     * Locality and geo-ecological description of the locality,
     * exactly as written on the original label (i.e. without
     * corrections during data entry).
     */
    private java.lang.String _localityDescription;

    /**
     * Title of label if different from ExsiccataTitle for printing
     * labels. Will be printed on label after ExsiccataTitle.
     */
    private java.lang.String _labelTitle;

    /**
     * Printed, typewritten, typewritten with handwriting added,
     * entirely in handwriting, etc.
     */
    private java.lang.String _labelType;

    /**
     * The state of the transcription of a label into the database:
     * 'Not started' / 'incomplete' / 'complete'.
     */
    private java.lang.String _labelTranscription;

    /**
     * User defined notes concerning the transcription of the label
     * into the database.
     */
    private java.lang.String _labelTranscriptionNotes;

    /**
     * Accession number of the specimen within the collection, e.g.
     * "M-29834752".
     */
    private java.lang.String _accessionNumber;

    /**
     * The day of the date when the specimen was acquired in the
     * collection.
     */
    private int _accessionDay;

    /**
     * keeps track of state for field: _accessionDay
     */
    private boolean _has_accessionDay;

    /**
     * The month of the date when the specimen was acquired in the
     * collection.
     */
    private int _accessionMonth;

    /**
     * keeps track of state for field: _accessionMonth
     */
    private boolean _has_accessionMonth;

    /**
     * The year when the specimen was acquired in the collection.
     * The year may be left empty if only the day or month are known
     */
    private short _accessionYear;

    /**
     * keeps track of state for field: _accessionYear
     */
    private boolean _has_accessionYear;

    /**
     * Verbal or additional accession date information, e.g. 'end
     * of summer 1985', 'first quarter', '1888-1892'.
     */
    private java.lang.String _accessionDateSupplement;

    /**
     * Category of the date of the identification e.g. "system",
     * "estimated" (= foreign key, see in table
     * xColl_DateCategory_Enum).
     */
    private java.lang.String _accessionDateCategory;

    /**
     * If specimen is an exsiccata: Unique reference ID for the
     * Exsiccata series as stored within the DiversityExsiccata
     * database.
     */
    private int _exsiccataID;

    /**
     * keeps track of state for field: _exsiccataID
     */
    private boolean _has_exsiccataID;

    /**
     * If specimen is an exsiccata: Standard abbreviation of the
     * exsiccata (not necessarily a unique identifier; editors or
     * publication places may change over time).
     */
    private java.lang.String _exsiccataAbbreviation;

    /**
     * If specimen is an exsiccata: Number of current specimen
     * within the exsiccata series.
     */
    private java.lang.String _exsiccataNumber;

    /**
     * The name of the depositor(s) (person or organization
     * responsible for deposition). Where entire collections are
     * deposited, this should also contain the collection name
     * (e.g. 'Herbarium P. Dbbler').
     */
    private java.lang.String _depositorsName;

    /**
     * Accession number of the specimen within the previous or
     * original collection, e.g. 'D-23948'.
     */
    private java.lang.String _depositorsAccessionNumber;

    /**
     * Notes found on the label of the specimen, by the original
     * collector or from a later revision.
     */
    private java.lang.String _originalNotes;

    /**
     * Additional notes made by the editor of the specimen record,
     * e. g. 'doubtful identification/locality'.
     */
    private java.lang.String _additionalNotes;

    /**
     * Notes if the item is on loan or has been borrowed.
     */
    private java.lang.String _loanInformation;

    /**
     * Description of a problem that occurred during data editing.
     * Typically these entries should be deleted after help has
     * been obtained. Do not enter scientific problems here; use
     * AdditionalNotes for such permanent problems!
     */
    private java.lang.String _problems;

    /**
     * Is set to true if the label should be printed, is set to
     * false if the label should not be printed.
     */
    private boolean _printLabel;

    /**
     * keeps track of state for field: _printLabel
     */
    private boolean _has_printLabel;

    /**
     * ID of the user who first entered (typed or imported) the
     * data. This is the operator (or typist) name, which may be
     * different from the person responsible.
     */
    private int _logCreatedBy;

    /**
     * keeps track of state for field: _logCreatedBy
     */
    private boolean _has_logCreatedBy;

    /**
     * Date and time when record was first entered (= typed or
     * imported) into this system. (Note: Updates are recorded in
     * CollectionSpecimenChanges).
     */
    private java.util.Date _logCreatedWhen;


      //----------------/
     //- Constructors -/
    //----------------/

    public CollectionSpecimen() {
        super();
    } //-- net.metadiversity.diversity.navigator.db.ub_094.collection.CollectionSpecimen()


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method deleteAccessionDay
     */
    public void deleteAccessionDay()
    {
        this._has_accessionDay= false;
    } //-- void deleteAccessionDay() 

    /**
     * Method deleteAccessionMonth
     */
    public void deleteAccessionMonth()
    {
        this._has_accessionMonth= false;
    } //-- void deleteAccessionMonth() 

    /**
     * Method deleteAccessionYear
     */
    public void deleteAccessionYear()
    {
        this._has_accessionYear= false;
    } //-- void deleteAccessionYear() 

    /**
     * Method deleteCollectionDay
     */
    public void deleteCollectionDay()
    {
        this._has_collectionDay= false;
    } //-- void deleteCollectionDay() 

    /**
     * Method deleteCollectionMonth
     */
    public void deleteCollectionMonth()
    {
        this._has_collectionMonth= false;
    } //-- void deleteCollectionMonth() 

    /**
     * Method deleteCollectionSpecimenID
     */
    public void deleteCollectionSpecimenID()
    {
        this._has_collectionSpecimenID= false;
    } //-- void deleteCollectionSpecimenID() 

    /**
     * Method deleteCollectionYear
     */
    public void deleteCollectionYear()
    {
        this._has_collectionYear= false;
    } //-- void deleteCollectionYear() 

    /**
     * Method deleteExsiccataID
     */
    public void deleteExsiccataID()
    {
        this._has_exsiccataID= false;
    } //-- void deleteExsiccataID() 

    /**
     * Method deleteLogCreatedBy
     */
    public void deleteLogCreatedBy()
    {
        this._has_logCreatedBy= false;
    } //-- void deleteLogCreatedBy() 

    /**
     * Method deletePrintLabel
     */
    public void deletePrintLabel()
    {
        this._has_printLabel= false;
    } //-- void deletePrintLabel() 

    /**
     * Returns the value of field 'accessionDateCategory'. The
     * field 'accessionDateCategory' has the following description:
     * Category of the date of the identification e.g. "system",
     * "estimated" (= foreign key, see in table
     * xColl_DateCategory_Enum).
     * 
     * @return the value of field 'accessionDateCategory'.
     */
    public java.lang.String getAccessionDateCategory()
    {
        return this._accessionDateCategory;
    } //-- java.lang.String getAccessionDateCategory() 

    /**
     * Returns the value of field 'accessionDateSupplement'. The
     * field 'accessionDateSupplement' has the following
     * description: Verbal or additional accession date
     * information, e.g. 'end of summer 1985', 'first quarter',
     * '1888-1892'.
     * 
     * @return the value of field 'accessionDateSupplement'.
     */
    public java.lang.String getAccessionDateSupplement()
    {
        return this._accessionDateSupplement;
    } //-- java.lang.String getAccessionDateSupplement() 

    /**
     * Returns the value of field 'accessionDay'. The field
     * 'accessionDay' has the following description: The day of the
     * date when the specimen was acquired in the collection.
     * 
     * @return the value of field 'accessionDay'.
     */
    public int getAccessionDay()
    {
        return this._accessionDay;
    } //-- int getAccessionDay() 

    /**
     * Returns the value of field 'accessionMonth'. The field
     * 'accessionMonth' has the following description: The month of
     * the date when the specimen was acquired in the collection.
     * 
     * @return the value of field 'accessionMonth'.
     */
    public int getAccessionMonth()
    {
        return this._accessionMonth;
    } //-- int getAccessionMonth() 

    /**
     * Returns the value of field 'accessionNumber'. The field
     * 'accessionNumber' has the following description: Accession
     * number of the specimen within the collection, e.g.
     * "M-29834752".
     * 
     * @return the value of field 'accessionNumber'.
     */
    public java.lang.String getAccessionNumber()
    {
        return this._accessionNumber;
    } //-- java.lang.String getAccessionNumber() 

    /**
     * Returns the value of field 'accessionYear'. The field
     * 'accessionYear' has the following description: The year when
     * the specimen was acquired in the collection. The year may be
     * left empty if only the day or month are known.
     * 
     * @return the value of field 'accessionYear'.
     */
    public short getAccessionYear()
    {
        return this._accessionYear;
    } //-- short getAccessionYear() 

    /**
     * Returns the value of field 'additionalNotes'. The field
     * 'additionalNotes' has the following description: Additional
     * notes made by the editor of the specimen record, e. g.
     * 'doubtful identification/locality'.
     * 
     * @return the value of field 'additionalNotes'.
     */
    public java.lang.String getAdditionalNotes()
    {
        return this._additionalNotes;
    } //-- java.lang.String getAdditionalNotes() 

    /**
     * Returns the value of field 'collectionDateCache'. The field
     * 'collectionDateCache' has the following description: Date of
     * the collection event (calculated value based on
     * CollectionDay, Month, and Year; if day or month are missing
     * they are assumed to be '1' for the purpose of the date
     * calculation).
     * 
     * @return the value of field 'collectionDateCache'.
     */
    public java.util.Date getCollectionDateCache()
    {
        return this._collectionDateCache;
    } //-- java.util.Date getCollectionDateCache() 

    /**
     * Returns the value of field 'collectionDateCategory'. The
     * field 'collectionDateCategory' has the following
     * description: Category of the date of the identification e.g.
     * "system", "estimated" (= foreign key, see in table
     * xColl_DateCategory_Enum).
     * 
     * @return the value of field 'collectionDateCategory'.
     */
    public java.lang.String getCollectionDateCategory()
    {
        return this._collectionDateCategory;
    } //-- java.lang.String getCollectionDateCategory() 

    /**
     * Returns the value of field 'collectionDateSupplement'. The
     * field 'collectionDateSupplement' has the following
     * description: Verbal or additional collection date
     * information, e.g. 'end of summer 1985', 'first quarter',
     * '1888-1892'.
     * 
     * @return the value of field 'collectionDateSupplement'.
     */
    public java.lang.String getCollectionDateSupplement()
    {
        return this._collectionDateSupplement;
    } //-- java.lang.String getCollectionDateSupplement() 

    /**
     * Returns the value of field 'collectionDay'. The field
     * 'collectionDay' has the following description: The day of
     * the date of the collection event.
     * 
     * @return the value of field 'collectionDay'.
     */
    public int getCollectionDay()
    {
        return this._collectionDay;
    } //-- int getCollectionDay() 

    /**
     * Returns the value of field 'collectionMonth'. The field
     * 'collectionMonth' has the following description: The month
     * of the date of the collection event.
     * 
     * @return the value of field 'collectionMonth'.
     */
    public int getCollectionMonth()
    {
        return this._collectionMonth;
    } //-- int getCollectionMonth() 

    /**
     * Returns the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: Unique
     * reference ID for the collection specimen record (primary
     * key).
     * 
     * @return the value of field 'collectionSpecimenID'.
     */
    public int getCollectionSpecimenID()
    {
        return this._collectionSpecimenID;
    } //-- int getCollectionSpecimenID() 

    /**
     * Returns the value of field 'collectionYear'. The field
     * 'collectionYear' has the following description: The year of
     * the collection event. The year may be left empty if only the
     * day or month are known.
     * 
     * @return the value of field 'collectionYear'.
     */
    public short getCollectionYear()
    {
        return this._collectionYear;
    } //-- short getCollectionYear() 

    /**
     * Returns the value of field 'depositorsAccessionNumber'. The
     * field 'depositorsAccessionNumber' has the following
     * description: Accession number of the specimen within the
     * previous or original collection, e.g. 'D-23948'.
     * 
     * @return the value of field 'depositorsAccessionNumber'.
     */
    public java.lang.String getDepositorsAccessionNumber()
    {
        return this._depositorsAccessionNumber;
    } //-- java.lang.String getDepositorsAccessionNumber() 

    /**
     * Returns the value of field 'depositorsName'. The field
     * 'depositorsName' has the following description: The name of
     * the depositor(s) (person or organization responsible for
     * deposition). Where entire collections are deposited, this
     * should also contain the collection name (e.g. 'Herbarium P.
     * Dbbler').
     * 
     * @return the value of field 'depositorsName'.
     */
    public java.lang.String getDepositorsName()
    {
        return this._depositorsName;
    } //-- java.lang.String getDepositorsName() 

    /**
     * Returns the value of field 'exsiccataAbbreviation'. The
     * field 'exsiccataAbbreviation' has the following description:
     * If specimen is an exsiccata: Standard abbreviation of the
     * exsiccata (not necessarily a unique identifier; editors or
     * publication places may change over time).
     * 
     * @return the value of field 'exsiccataAbbreviation'.
     */
    public java.lang.String getExsiccataAbbreviation()
    {
        return this._exsiccataAbbreviation;
    } //-- java.lang.String getExsiccataAbbreviation() 

    /**
     * Returns the value of field 'exsiccataID'. The field
     * 'exsiccataID' has the following description: If specimen is
     * an exsiccata: Unique reference ID for the Exsiccata series
     * as stored within the DiversityExsiccata database.
     * 
     * @return the value of field 'exsiccataID'.
     */
    public int getExsiccataID()
    {
        return this._exsiccataID;
    } //-- int getExsiccataID() 

    /**
     * Returns the value of field 'exsiccataNumber'. The field
     * 'exsiccataNumber' has the following description: If specimen
     * is an exsiccata: Number of current specimen within the
     * exsiccata series.
     * 
     * @return the value of field 'exsiccataNumber'.
     */
    public java.lang.String getExsiccataNumber()
    {
        return this._exsiccataNumber;
    } //-- java.lang.String getExsiccataNumber() 

    /**
     * Returns the value of field 'labelTitle'. The field
     * 'labelTitle' has the following description: Title of label
     * if different from ExsiccataTitle for printing labels. Will
     * be printed on label after ExsiccataTitle.
     * 
     * @return the value of field 'labelTitle'.
     */
    public java.lang.String getLabelTitle()
    {
        return this._labelTitle;
    } //-- java.lang.String getLabelTitle() 

    /**
     * Returns the value of field 'labelTranscription'. The field
     * 'labelTranscription' has the following description: The
     * state of the transcription of a label into the database:
     * 'Not started' / 'incomplete' / 'complete'.
     * 
     * @return the value of field 'labelTranscription'.
     */
    public java.lang.String getLabelTranscription()
    {
        return this._labelTranscription;
    } //-- java.lang.String getLabelTranscription() 

    /**
     * Returns the value of field 'labelTranscriptionNotes'. The
     * field 'labelTranscriptionNotes' has the following
     * description: User defined notes concerning the transcription
     * of the label into the database.
     * 
     * @return the value of field 'labelTranscriptionNotes'.
     */
    public java.lang.String getLabelTranscriptionNotes()
    {
        return this._labelTranscriptionNotes;
    } //-- java.lang.String getLabelTranscriptionNotes() 

    /**
     * Returns the value of field 'labelType'. The field
     * 'labelType' has the following description: Printed,
     * typewritten, typewritten with handwriting added, entirely in
     * handwriting, etc.
     * 
     * @return the value of field 'labelType'.
     */
    public java.lang.String getLabelType()
    {
        return this._labelType;
    } //-- java.lang.String getLabelType() 

    /**
     * Returns the value of field 'loanInformation'. The field
     * 'loanInformation' has the following description: Notes if
     * the item is on loan or has been borrowed.
     * 
     * @return the value of field 'loanInformation'.
     */
    public java.lang.String getLoanInformation()
    {
        return this._loanInformation;
    } //-- java.lang.String getLoanInformation() 

    /**
     * Returns the value of field 'localityDescription'. The field
     * 'localityDescription' has the following description:
     * Locality and geo-ecological description of the locality,
     * exactly as written on the original label (i.e. without
     * corrections during data entry).
     * 
     * @return the value of field 'localityDescription'.
     */
    public java.lang.String getLocalityDescription()
    {
        return this._localityDescription;
    } //-- java.lang.String getLocalityDescription() 

    /**
     * Returns the value of field 'logCreatedBy'. The field
     * 'logCreatedBy' has the following description: ID of the user
     * who first entered (typed or imported) the data. This is the
     * operator (or typist) name, which may be different from the
     * person responsible.
     * 
     * @return the value of field 'logCreatedBy'.
     */
    public int getLogCreatedBy()
    {
        return this._logCreatedBy;
    } //-- int getLogCreatedBy() 

    /**
     * Returns the value of field 'logCreatedWhen'. The field
     * 'logCreatedWhen' has the following description: Date and
     * time when record was first entered (= typed or imported)
     * into this system. (Note: Updates are recorded in
     * CollectionSpecimenChanges).
     * 
     * @return the value of field 'logCreatedWhen'.
     */
    public java.util.Date getLogCreatedWhen()
    {
        return this._logCreatedWhen;
    } //-- java.util.Date getLogCreatedWhen() 

    /**
     * Returns the value of field 'originalNotes'. The field
     * 'originalNotes' has the following description: Notes found
     * on the label of the specimen, by the original collector or
     * from a later revision.
     * 
     * @return the value of field 'originalNotes'.
     */
    public java.lang.String getOriginalNotes()
    {
        return this._originalNotes;
    } //-- java.lang.String getOriginalNotes() 

    /**
     * Returns the value of field 'printLabel'. The field
     * 'printLabel' has the following description: Is set to true
     * if the label should be printed, is set to false if the label
     * should not be printed.
     * 
     * @return the value of field 'printLabel'.
     */
    public boolean getPrintLabel()
    {
        return this._printLabel;
    } //-- boolean getPrintLabel() 

    /**
     * Returns the value of field 'problems'. The field 'problems'
     * has the following description: Description of a problem that
     * occurred during data editing. Typically these entries should
     * be deleted after help has been obtained. Do not enter
     * scientific problems here; use AdditionalNotes for such
     * permanent problems!
     * 
     * @return the value of field 'problems'.
     */
    public java.lang.String getProblems()
    {
        return this._problems;
    } //-- java.lang.String getProblems() 

    /**
     * Method hasAccessionDay
     */
    public boolean hasAccessionDay()
    {
        return this._has_accessionDay;
    } //-- boolean hasAccessionDay() 

    /**
     * Method hasAccessionMonth
     */
    public boolean hasAccessionMonth()
    {
        return this._has_accessionMonth;
    } //-- boolean hasAccessionMonth() 

    /**
     * Method hasAccessionYear
     */
    public boolean hasAccessionYear()
    {
        return this._has_accessionYear;
    } //-- boolean hasAccessionYear() 

    /**
     * Method hasCollectionDay
     */
    public boolean hasCollectionDay()
    {
        return this._has_collectionDay;
    } //-- boolean hasCollectionDay() 

    /**
     * Method hasCollectionMonth
     */
    public boolean hasCollectionMonth()
    {
        return this._has_collectionMonth;
    } //-- boolean hasCollectionMonth() 

    /**
     * Method hasCollectionSpecimenID
     */
    public boolean hasCollectionSpecimenID()
    {
        return this._has_collectionSpecimenID;
    } //-- boolean hasCollectionSpecimenID() 

    /**
     * Method hasCollectionYear
     */
    public boolean hasCollectionYear()
    {
        return this._has_collectionYear;
    } //-- boolean hasCollectionYear() 

    /**
     * Method hasExsiccataID
     */
    public boolean hasExsiccataID()
    {
        return this._has_exsiccataID;
    } //-- boolean hasExsiccataID() 

    /**
     * Method hasLogCreatedBy
     */
    public boolean hasLogCreatedBy()
    {
        return this._has_logCreatedBy;
    } //-- boolean hasLogCreatedBy() 

    /**
     * Method hasPrintLabel
     */
    public boolean hasPrintLabel()
    {
        return this._has_printLabel;
    } //-- boolean hasPrintLabel() 

    /**
     * Method isValid
     */
    public boolean isValid()
    {
        try {
            validate();
        }
        catch (org.exolab.castor.xml.ValidationException vex) {
            return false;
        }
        return true;
    } //-- boolean isValid() 

    /**
     * Method marshal
     * 
     * @param out
     */
    public void marshal(java.io.Writer out)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, out);
    } //-- void marshal(java.io.Writer) 

    /**
     * Method marshal
     * 
     * @param handler
     */
    public void marshal(org.xml.sax.ContentHandler handler)
        throws java.io.IOException, org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, handler);
    } //-- void marshal(org.xml.sax.ContentHandler) 

    /**
     * Sets the value of field 'accessionDateCategory'. The field
     * 'accessionDateCategory' has the following description:
     * Category of the date of the identification e.g. "system",
     * "estimated" (= foreign key, see in table
     * xColl_DateCategory_Enum).
     * 
     * @param accessionDateCategory the value of field
     * 'accessionDateCategory'.
     */
    public void setAccessionDateCategory(java.lang.String accessionDateCategory)
    {
        this._accessionDateCategory = accessionDateCategory;
    } //-- void setAccessionDateCategory(java.lang.String) 

    /**
     * Sets the value of field 'accessionDateSupplement'. The field
     * 'accessionDateSupplement' has the following description:
     * Verbal or additional accession date information, e.g. 'end
     * of summer 1985', 'first quarter', '1888-1892'.
     * 
     * @param accessionDateSupplement the value of field
     * 'accessionDateSupplement'.
     */
    public void setAccessionDateSupplement(java.lang.String accessionDateSupplement)
    {
        this._accessionDateSupplement = accessionDateSupplement;
    } //-- void setAccessionDateSupplement(java.lang.String) 

    /**
     * Sets the value of field 'accessionDay'. The field
     * 'accessionDay' has the following description: The day of the
     * date when the specimen was acquired in the collection.
     * 
     * @param accessionDay the value of field 'accessionDay'.
     */
    public void setAccessionDay(int accessionDay)
    {
        this._accessionDay = accessionDay;
        this._has_accessionDay = true;
    } //-- void setAccessionDay(int) 

    /**
     * Sets the value of field 'accessionMonth'. The field
     * 'accessionMonth' has the following description: The month of
     * the date when the specimen was acquired in the collection.
     * 
     * @param accessionMonth the value of field 'accessionMonth'.
     */
    public void setAccessionMonth(int accessionMonth)
    {
        this._accessionMonth = accessionMonth;
        this._has_accessionMonth = true;
    } //-- void setAccessionMonth(int) 

    /**
     * Sets the value of field 'accessionNumber'. The field
     * 'accessionNumber' has the following description: Accession
     * number of the specimen within the collection, e.g.
     * "M-29834752".
     * 
     * @param accessionNumber the value of field 'accessionNumber'.
     */
    public void setAccessionNumber(java.lang.String accessionNumber)
    {
        this._accessionNumber = accessionNumber;
    } //-- void setAccessionNumber(java.lang.String) 

    /**
     * Sets the value of field 'accessionYear'. The field
     * 'accessionYear' has the following description: The year when
     * the specimen was acquired in the collection. The year may be
     * left empty if only the day or month are known.
     * 
     * @param accessionYear the value of field 'accessionYear'.
     */
    public void setAccessionYear(short accessionYear)
    {
        this._accessionYear = accessionYear;
        this._has_accessionYear = true;
    } //-- void setAccessionYear(short) 

    /**
     * Sets the value of field 'additionalNotes'. The field
     * 'additionalNotes' has the following description: Additional
     * notes made by the editor of the specimen record, e. g.
     * 'doubtful identification/locality'.
     * 
     * @param additionalNotes the value of field 'additionalNotes'.
     */
    public void setAdditionalNotes(java.lang.String additionalNotes)
    {
        this._additionalNotes = additionalNotes;
    } //-- void setAdditionalNotes(java.lang.String) 

    /**
     * Sets the value of field 'collectionDateCache'. The field
     * 'collectionDateCache' has the following description: Date of
     * the collection event (calculated value based on
     * CollectionDay, Month, and Year; if day or month are missing
     * they are assumed to be '1' for the purpose of the date
     * calculation).
     * 
     * @param collectionDateCache the value of field
     * 'collectionDateCache'.
     */
    public void setCollectionDateCache(java.util.Date collectionDateCache)
    {
        this._collectionDateCache = collectionDateCache;
    } //-- void setCollectionDateCache(java.util.Date) 

    /**
     * Sets the value of field 'collectionDateCategory'. The field
     * 'collectionDateCategory' has the following description:
     * Category of the date of the identification e.g. "system",
     * "estimated" (= foreign key, see in table
     * xColl_DateCategory_Enum).
     * 
     * @param collectionDateCategory the value of field
     * 'collectionDateCategory'.
     */
    public void setCollectionDateCategory(java.lang.String collectionDateCategory)
    {
        this._collectionDateCategory = collectionDateCategory;
    } //-- void setCollectionDateCategory(java.lang.String) 

    /**
     * Sets the value of field 'collectionDateSupplement'. The
     * field 'collectionDateSupplement' has the following
     * description: Verbal or additional collection date
     * information, e.g. 'end of summer 1985', 'first quarter',
     * '1888-1892'.
     * 
     * @param collectionDateSupplement the value of field
     * 'collectionDateSupplement'.
     */
    public void setCollectionDateSupplement(java.lang.String collectionDateSupplement)
    {
        this._collectionDateSupplement = collectionDateSupplement;
    } //-- void setCollectionDateSupplement(java.lang.String) 

    /**
     * Sets the value of field 'collectionDay'. The field
     * 'collectionDay' has the following description: The day of
     * the date of the collection event.
     * 
     * @param collectionDay the value of field 'collectionDay'.
     */
    public void setCollectionDay(int collectionDay)
    {
        this._collectionDay = collectionDay;
        this._has_collectionDay = true;
    } //-- void setCollectionDay(int) 

    /**
     * Sets the value of field 'collectionMonth'. The field
     * 'collectionMonth' has the following description: The month
     * of the date of the collection event.
     * 
     * @param collectionMonth the value of field 'collectionMonth'.
     */
    public void setCollectionMonth(int collectionMonth)
    {
        this._collectionMonth = collectionMonth;
        this._has_collectionMonth = true;
    } //-- void setCollectionMonth(int) 

    /**
     * Sets the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: Unique
     * reference ID for the collection specimen record (primary
     * key).
     * 
     * @param collectionSpecimenID the value of field
     * 'collectionSpecimenID'.
     */
    public void setCollectionSpecimenID(int collectionSpecimenID)
    {
        this._collectionSpecimenID = collectionSpecimenID;
        this._has_collectionSpecimenID = true;
    } //-- void setCollectionSpecimenID(int) 

    /**
     * Sets the value of field 'collectionYear'. The field
     * 'collectionYear' has the following description: The year of
     * the collection event. The year may be left empty if only the
     * day or month are known.
     * 
     * @param collectionYear the value of field 'collectionYear'.
     */
    public void setCollectionYear(short collectionYear)
    {
        this._collectionYear = collectionYear;
        this._has_collectionYear = true;
    } //-- void setCollectionYear(short) 

    /**
     * Sets the value of field 'depositorsAccessionNumber'. The
     * field 'depositorsAccessionNumber' has the following
     * description: Accession number of the specimen within the
     * previous or original collection, e.g. 'D-23948'.
     * 
     * @param depositorsAccessionNumber the value of field
     * 'depositorsAccessionNumber'.
     */
    public void setDepositorsAccessionNumber(java.lang.String depositorsAccessionNumber)
    {
        this._depositorsAccessionNumber = depositorsAccessionNumber;
    } //-- void setDepositorsAccessionNumber(java.lang.String) 

    /**
     * Sets the value of field 'depositorsName'. The field
     * 'depositorsName' has the following description: The name of
     * the depositor(s) (person or organization responsible for
     * deposition). Where entire collections are deposited, this
     * should also contain the collection name (e.g. 'Herbarium P.
     * Dbbler').
     * 
     * @param depositorsName the value of field 'depositorsName'.
     */
    public void setDepositorsName(java.lang.String depositorsName)
    {
        this._depositorsName = depositorsName;
    } //-- void setDepositorsName(java.lang.String) 

    /**
     * Sets the value of field 'exsiccataAbbreviation'. The field
     * 'exsiccataAbbreviation' has the following description: If
     * specimen is an exsiccata: Standard abbreviation of the
     * exsiccata (not necessarily a unique identifier; editors or
     * publication places may change over time).
     * 
     * @param exsiccataAbbreviation the value of field
     * 'exsiccataAbbreviation'.
     */
    public void setExsiccataAbbreviation(java.lang.String exsiccataAbbreviation)
    {
        this._exsiccataAbbreviation = exsiccataAbbreviation;
    } //-- void setExsiccataAbbreviation(java.lang.String) 

    /**
     * Sets the value of field 'exsiccataID'. The field
     * 'exsiccataID' has the following description: If specimen is
     * an exsiccata: Unique reference ID for the Exsiccata series
     * as stored within the DiversityExsiccata database.
     * 
     * @param exsiccataID the value of field 'exsiccataID'.
     */
    public void setExsiccataID(int exsiccataID)
    {
        this._exsiccataID = exsiccataID;
        this._has_exsiccataID = true;
    } //-- void setExsiccataID(int) 

    /**
     * Sets the value of field 'exsiccataNumber'. The field
     * 'exsiccataNumber' has the following description: If specimen
     * is an exsiccata: Number of current specimen within the
     * exsiccata series.
     * 
     * @param exsiccataNumber the value of field 'exsiccataNumber'.
     */
    public void setExsiccataNumber(java.lang.String exsiccataNumber)
    {
        this._exsiccataNumber = exsiccataNumber;
    } //-- void setExsiccataNumber(java.lang.String) 

    /**
     * Sets the value of field 'labelTitle'. The field 'labelTitle'
     * has the following description: Title of label if different
     * from ExsiccataTitle for printing labels. Will be printed on
     * label after ExsiccataTitle.
     * 
     * @param labelTitle the value of field 'labelTitle'.
     */
    public void setLabelTitle(java.lang.String labelTitle)
    {
        this._labelTitle = labelTitle;
    } //-- void setLabelTitle(java.lang.String) 

    /**
     * Sets the value of field 'labelTranscription'. The field
     * 'labelTranscription' has the following description: The
     * state of the transcription of a label into the database:
     * 'Not started' / 'incomplete' / 'complete'.
     * 
     * @param labelTranscription the value of field
     * 'labelTranscription'.
     */
    public void setLabelTranscription(java.lang.String labelTranscription)
    {
        this._labelTranscription = labelTranscription;
    } //-- void setLabelTranscription(java.lang.String) 

    /**
     * Sets the value of field 'labelTranscriptionNotes'. The field
     * 'labelTranscriptionNotes' has the following description:
     * User defined notes concerning the transcription of the label
     * into the database.
     * 
     * @param labelTranscriptionNotes the value of field
     * 'labelTranscriptionNotes'.
     */
    public void setLabelTranscriptionNotes(java.lang.String labelTranscriptionNotes)
    {
        this._labelTranscriptionNotes = labelTranscriptionNotes;
    } //-- void setLabelTranscriptionNotes(java.lang.String) 

    /**
     * Sets the value of field 'labelType'. The field 'labelType'
     * has the following description: Printed, typewritten,
     * typewritten with handwriting added, entirely in handwriting,
     * etc.
     * 
     * @param labelType the value of field 'labelType'.
     */
    public void setLabelType(java.lang.String labelType)
    {
        this._labelType = labelType;
    } //-- void setLabelType(java.lang.String) 

    /**
     * Sets the value of field 'loanInformation'. The field
     * 'loanInformation' has the following description: Notes if
     * the item is on loan or has been borrowed.
     * 
     * @param loanInformation the value of field 'loanInformation'.
     */
    public void setLoanInformation(java.lang.String loanInformation)
    {
        this._loanInformation = loanInformation;
    } //-- void setLoanInformation(java.lang.String) 

    /**
     * Sets the value of field 'localityDescription'. The field
     * 'localityDescription' has the following description:
     * Locality and geo-ecological description of the locality,
     * exactly as written on the original label (i.e. without
     * corrections during data entry).
     * 
     * @param localityDescription the value of field
     * 'localityDescription'.
     */
    public void setLocalityDescription(java.lang.String localityDescription)
    {
        this._localityDescription = localityDescription;
    } //-- void setLocalityDescription(java.lang.String) 

    /**
     * Sets the value of field 'logCreatedBy'. The field
     * 'logCreatedBy' has the following description: ID of the user
     * who first entered (typed or imported) the data. This is the
     * operator (or typist) name, which may be different from the
     * person responsible.
     * 
     * @param logCreatedBy the value of field 'logCreatedBy'.
     */
    public void setLogCreatedBy(int logCreatedBy)
    {
        this._logCreatedBy = logCreatedBy;
        this._has_logCreatedBy = true;
    } //-- void setLogCreatedBy(int) 

    /**
     * Sets the value of field 'logCreatedWhen'. The field
     * 'logCreatedWhen' has the following description: Date and
     * time when record was first entered (= typed or imported)
     * into this system. (Note: Updates are recorded in
     * CollectionSpecimenChanges).
     * 
     * @param logCreatedWhen the value of field 'logCreatedWhen'.
     */
    public void setLogCreatedWhen(java.util.Date logCreatedWhen)
    {
        this._logCreatedWhen = logCreatedWhen;
    } //-- void setLogCreatedWhen(java.util.Date) 

    /**
     * Sets the value of field 'originalNotes'. The field
     * 'originalNotes' has the following description: Notes found
     * on the label of the specimen, by the original collector or
     * from a later revision.
     * 
     * @param originalNotes the value of field 'originalNotes'.
     */
    public void setOriginalNotes(java.lang.String originalNotes)
    {
        this._originalNotes = originalNotes;
    } //-- void setOriginalNotes(java.lang.String) 

    /**
     * Sets the value of field 'printLabel'. The field 'printLabel'
     * has the following description: Is set to true if the label
     * should be printed, is set to false if the label should not
     * be printed.
     * 
     * @param printLabel the value of field 'printLabel'.
     */
    public void setPrintLabel(boolean printLabel)
    {
        this._printLabel = printLabel;
        this._has_printLabel = true;
    } //-- void setPrintLabel(boolean) 

    /**
     * Sets the value of field 'problems'. The field 'problems' has
     * the following description: Description of a problem that
     * occurred during data editing. Typically these entries should
     * be deleted after help has been obtained. Do not enter
     * scientific problems here; use AdditionalNotes for such
     * permanent problems!
     * 
     * @param problems the value of field 'problems'.
     */
    public void setProblems(java.lang.String problems)
    {
        this._problems = problems;
    } //-- void setProblems(java.lang.String) 

    /**
     * Method unmarshal
     * 
     * @param reader
     */
    public static java.lang.Object unmarshal(java.io.Reader reader)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        return (net.metadiversity.diversity.navigator.db.ub_094.collection.CollectionSpecimen) Unmarshaller.unmarshal(net.metadiversity.diversity.navigator.db.ub_094.collection.CollectionSpecimen.class, reader);
    } //-- java.lang.Object unmarshal(java.io.Reader) 

    /**
     * Method validate
     */
    public void validate()
        throws org.exolab.castor.xml.ValidationException
    {
        org.exolab.castor.xml.Validator validator = new org.exolab.castor.xml.Validator();
        validator.validate(this);
    } //-- void validate() 

}
