/*
 * This class was automatically generated with 
 * <a href="http://www.castor.org">Castor 0.9.5.2</a>, using an XML
 * Schema.
 * $Id: Identification.java,v 1.1 2003/12/11 14:48:57 didi Exp $
 */

package net.metadiversity.diversity.navigator.db.ub_094.collection;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.IOException;
import java.io.Reader;
import java.io.Serializable;
import java.io.Writer;
import java.util.Date;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.xml.Unmarshaller;
import org.exolab.castor.xml.ValidationException;
import org.xml.sax.ContentHandler;

/**
 * Identifications of the identification units.
 * 
 * @version $Revision: 1.1 $ $Date: 2003/12/11 14:48:57 $
 */
public class Identification implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Refers to the ID of CollectionUnit (= foreign key and part
     * of primary key).
     */
    private int _identificationUnitID;

    /**
     * keeps track of state for field: _identificationUnitID
     */
    private boolean _has_identificationUnitID;

    /**
     * Refers to the ID of CollectionSpecimen (= foreign key and
     * part of primary key).
     */
    private int _collectionSpecimenID;

    /**
     * keeps track of state for field: _collectionSpecimenID
     */
    private boolean _has_collectionSpecimenID;

    /**
     * Date and time the identification was entered into the
     * system, defines the ordering of identifications (= part of
     * primary key). Note: this is usually not the date the
     * identification occurred!
     */
    private java.util.Date _identificationSequence;

    /**
     * Date of the identification event (calculated value based on
     * IdentificationDay, Month, and Year; if day or month are
     * missing they are assumed to be '1' for the purpose of the
     * date calculation).
     */
    private java.util.Date _identificationDateCache;

    /**
     * The day of the identification event.
     */
    private int _identificationDay;

    /**
     * keeps track of state for field: _identificationDay
     */
    private boolean _has_identificationDay;

    /**
     * The month of the identification event.
     */
    private int _identificationMonth;

    /**
     * keeps track of state for field: _identificationMonth
     */
    private boolean _has_identificationMonth;

    /**
     * The year of the identification event. The year may be empty
     * if only the day or month are known.
     */
    private short _identificationYear;

    /**
     * keeps track of state for field: _identificationYear
     */
    private boolean _has_identificationYear;

    /**
     * Verbal or additional identification date information, e.g.
     * 'end of summer 1985', 'first quarter', '1888-1892'.
     */
    private java.lang.String _identificationDateSupplement;

    /**
     * Category of the date of the identification e.g. "system",
     * "estimated" (= foreign key, see in table
     * xColl_DateCategory_Enum).
     */
    private java.lang.String _identificationDateCategory;

    /**
     * Name other than a taxonomic (= scientific) name, e.g.
     * 'pine', 'limestone', 'conifer', 'hardwood'.
     */
    private java.lang.String _vernacularName;

    /**
     * Valid name of the species (including the taxonomic author
     * where available. Example: 'Rosa canina L.'.
     */
    private java.lang.String _taxonomicName;

    /**
     * Unique ID code of the taxon. Refers to the NomID code of
     * TaxonomyName (= foreign key) in the DiversityTaxonomy
     * component.
     */
    private int _nomID;

    /**
     * keeps track of state for field: _nomID
     */
    private boolean _has_nomID;

    /**
     * Signature of the taxonomic name thesaurus from which NomID
     * is derived.
     */
    private int _nomThesaurusSignature;

    /**
     * keeps track of state for field: _nomThesaurusSignature
     */
    private boolean _has_nomThesaurusSignature;

    /**
     * Category of the identification e.g. 'determination',
     * 'confirmation', 'absence' (= foreign key, see table
     * xColl_IdentificationCategory_Enum).
     */
    private java.lang.String _identificationCategory;

    /**
     * Qualification of the identification e.g. "cf."," aff.", "sp.
     * nov." (= foreign key, see table
     * xColl_IdentificationQualifier_Enum).
     */
    private java.lang.String _identificationQualifier;

    /**
     * True if this is the most recent identification for an
     * organism. Calculated field. Note: only a single record per
     * identification unit can be set to true.
     */
    private boolean _isLastIdentificationCache;

    /**
     * keeps track of state for field: _isLastIdentificationCache
     */
    private boolean _has_isLastIdentificationCache;

    /**
     * Publications or authorititative opinions of scientist used
     * during the identification process. Example: enter
     * 'Schmeil-Fitschen 1995' if this field flora was used.
     */
    private java.lang.String _literatureUsed;

    /**
     * User defined notes, e.g. the reason for a re-determination /
     * change of the name, etc.
     */
    private java.lang.String _notes;

    /**
     * Defines the name under which the collection specimen is
     * published within an exsiccate. Can be set only once per
     * collection specimen.
     */
    private boolean _isExsiccataTaxon;

    /**
     * keeps track of state for field: _isExsiccataTaxon
     */
    private boolean _has_isExsiccataTaxon;

    /**
     * Name of the person or institution responsible for the
     * determination.
     */
    private java.lang.String _responsibleName;

    /**
     * ID of user who first entered (typed or imported) the data.
     * This is the operator (or typist) name, which may be
     * different from the person responsible.
     */
    private int _logCreatedBy;

    /**
     * keeps track of state for field: _logCreatedBy
     */
    private boolean _has_logCreatedBy;

    /**
     * Date and time when record was first entered (= typed or
     * imported) into this system.
     */
    private java.util.Date _logCreatedWhen;


      //----------------/
     //- Constructors -/
    //----------------/

    public Identification() {
        super();
    } //-- net.metadiversity.diversity.navigator.db.ub_094.collection.Identification()


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method deleteIdentificationDay
     */
    public void deleteIdentificationDay()
    {
        this._has_identificationDay= false;
    } //-- void deleteIdentificationDay() 

    /**
     * Method deleteIdentificationMonth
     */
    public void deleteIdentificationMonth()
    {
        this._has_identificationMonth= false;
    } //-- void deleteIdentificationMonth() 

    /**
     * Method deleteIdentificationYear
     */
    public void deleteIdentificationYear()
    {
        this._has_identificationYear= false;
    } //-- void deleteIdentificationYear() 

    /**
     * Method deleteIsExsiccataTaxon
     */
    public void deleteIsExsiccataTaxon()
    {
        this._has_isExsiccataTaxon= false;
    } //-- void deleteIsExsiccataTaxon() 

    /**
     * Method deleteIsLastIdentificationCache
     */
    public void deleteIsLastIdentificationCache()
    {
        this._has_isLastIdentificationCache= false;
    } //-- void deleteIsLastIdentificationCache() 

    /**
     * Method deleteNomID
     */
    public void deleteNomID()
    {
        this._has_nomID= false;
    } //-- void deleteNomID() 

    /**
     * Returns the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: Refers
     * to the ID of CollectionSpecimen (= foreign key and part of
     * primary key).
     * 
     * @return the value of field 'collectionSpecimenID'.
     */
    public int getCollectionSpecimenID()
    {
        return this._collectionSpecimenID;
    } //-- int getCollectionSpecimenID() 

    /**
     * Returns the value of field 'identificationCategory'. The
     * field 'identificationCategory' has the following
     * description: Category of the identification e.g.
     * 'determination', 'confirmation', 'absence' (= foreign key,
     * see table xColl_IdentificationCategory_Enum).
     * 
     * @return the value of field 'identificationCategory'.
     */
    public java.lang.String getIdentificationCategory()
    {
        return this._identificationCategory;
    } //-- java.lang.String getIdentificationCategory() 

    /**
     * Returns the value of field 'identificationDateCache'. The
     * field 'identificationDateCache' has the following
     * description: Date of the identification event (calculated
     * value based on IdentificationDay, Month, and Year; if day or
     * month are missing they are assumed to be '1' for the purpose
     * of the date calculation).
     * 
     * @return the value of field 'identificationDateCache'.
     */
    public java.util.Date getIdentificationDateCache()
    {
        return this._identificationDateCache;
    } //-- java.util.Date getIdentificationDateCache() 

    /**
     * Returns the value of field 'identificationDateCategory'. The
     * field 'identificationDateCategory' has the following
     * description: Category of the date of the identification e.g.
     * "system", "estimated" (= foreign key, see in table
     * xColl_DateCategory_Enum).
     * 
     * @return the value of field 'identificationDateCategory'.
     */
    public java.lang.String getIdentificationDateCategory()
    {
        return this._identificationDateCategory;
    } //-- java.lang.String getIdentificationDateCategory() 

    /**
     * Returns the value of field 'identificationDateSupplement'.
     * The field 'identificationDateSupplement' has the following
     * description: Verbal or additional identification date
     * information, e.g. 'end of summer 1985', 'first quarter',
     * '1888-1892'.
     * 
     * @return the value of field 'identificationDateSupplement'.
     */
    public java.lang.String getIdentificationDateSupplement()
    {
        return this._identificationDateSupplement;
    } //-- java.lang.String getIdentificationDateSupplement() 

    /**
     * Returns the value of field 'identificationDay'. The field
     * 'identificationDay' has the following description: The day
     * of the identification event.
     * 
     * @return the value of field 'identificationDay'.
     */
    public int getIdentificationDay()
    {
        return this._identificationDay;
    } //-- int getIdentificationDay() 

    /**
     * Returns the value of field 'identificationMonth'. The field
     * 'identificationMonth' has the following description: The
     * month of the identification event.
     * 
     * @return the value of field 'identificationMonth'.
     */
    public int getIdentificationMonth()
    {
        return this._identificationMonth;
    } //-- int getIdentificationMonth() 

    /**
     * Returns the value of field 'identificationQualifier'. The
     * field 'identificationQualifier' has the following
     * description: Qualification of the identification e.g.
     * "cf."," aff.", "sp. nov." (= foreign key, see table
     * xColl_IdentificationQualifier_Enum).
     * 
     * @return the value of field 'identificationQualifier'.
     */
    public java.lang.String getIdentificationQualifier()
    {
        return this._identificationQualifier;
    } //-- java.lang.String getIdentificationQualifier() 

    /**
     * Returns the value of field 'identificationSequence'. The
     * field 'identificationSequence' has the following
     * description: Date and time the identification was entered
     * into the system, defines the ordering of identifications (=
     * part of primary key). Note: this is usually not the date the
     * identification occurred!
     * 
     * @return the value of field 'identificationSequence'.
     */
    public java.util.Date getIdentificationSequence()
    {
        return this._identificationSequence;
    } //-- java.util.Date getIdentificationSequence() 

    /**
     * Returns the value of field 'identificationUnitID'. The field
     * 'identificationUnitID' has the following description: Refers
     * to the ID of CollectionUnit (= foreign key and part of
     * primary key).
     * 
     * @return the value of field 'identificationUnitID'.
     */
    public int getIdentificationUnitID()
    {
        return this._identificationUnitID;
    } //-- int getIdentificationUnitID() 

    /**
     * Returns the value of field 'identificationYear'. The field
     * 'identificationYear' has the following description: The year
     * of the identification event. The year may be empty if only
     * the day or month are known.
     * 
     * @return the value of field 'identificationYear'.
     */
    public short getIdentificationYear()
    {
        return this._identificationYear;
    } //-- short getIdentificationYear() 

    /**
     * Returns the value of field 'isExsiccataTaxon'. The field
     * 'isExsiccataTaxon' has the following description: Defines
     * the name under which the collection specimen is published
     * within an exsiccate. Can be set only once per collection
     * specimen.
     * 
     * @return the value of field 'isExsiccataTaxon'.
     */
    public boolean getIsExsiccataTaxon()
    {
        return this._isExsiccataTaxon;
    } //-- boolean getIsExsiccataTaxon() 

    /**
     * Returns the value of field 'isLastIdentificationCache'. The
     * field 'isLastIdentificationCache' has the following
     * description: True if this is the most recent identification
     * for an organism. Calculated field. Note: only a single
     * record per identification unit can be set to true.
     * 
     * @return the value of field 'isLastIdentificationCache'.
     */
    public boolean getIsLastIdentificationCache()
    {
        return this._isLastIdentificationCache;
    } //-- boolean getIsLastIdentificationCache() 

    /**
     * Returns the value of field 'literatureUsed'. The field
     * 'literatureUsed' has the following description: Publications
     * or authorititative opinions of scientist used during the
     * identification process. Example: enter 'Schmeil-Fitschen
     * 1995' if this field flora was used.
     * 
     * @return the value of field 'literatureUsed'.
     */
    public java.lang.String getLiteratureUsed()
    {
        return this._literatureUsed;
    } //-- java.lang.String getLiteratureUsed() 

    /**
     * Returns the value of field 'logCreatedBy'. The field
     * 'logCreatedBy' has the following description: ID of user who
     * first entered (typed or imported) the data. This is the
     * operator (or typist) name, which may be different from the
     * person responsible.
     * 
     * @return the value of field 'logCreatedBy'.
     */
    public int getLogCreatedBy()
    {
        return this._logCreatedBy;
    } //-- int getLogCreatedBy() 

    /**
     * Returns the value of field 'logCreatedWhen'. The field
     * 'logCreatedWhen' has the following description: Date and
     * time when record was first entered (= typed or imported)
     * into this system.
     * 
     * @return the value of field 'logCreatedWhen'.
     */
    public java.util.Date getLogCreatedWhen()
    {
        return this._logCreatedWhen;
    } //-- java.util.Date getLogCreatedWhen() 

    /**
     * Returns the value of field 'nomID'. The field 'nomID' has
     * the following description: Unique ID code of the taxon.
     * Refers to the NomID code of TaxonomyName (= foreign key) in
     * the DiversityTaxonomy component.
     * 
     * @return the value of field 'nomID'.
     */
    public int getNomID()
    {
        return this._nomID;
    } //-- int getNomID() 

    /**
     * Returns the value of field 'nomThesaurusSignature'. The
     * field 'nomThesaurusSignature' has the following description:
     * Signature of the taxonomic name thesaurus from which NomID
     * is derived.
     * 
     * @return the value of field 'nomThesaurusSignature'.
     */
    public int getNomThesaurusSignature()
    {
        return this._nomThesaurusSignature;
    } //-- int getNomThesaurusSignature() 

    /**
     * Returns the value of field 'notes'. The field 'notes' has
     * the following description: User defined notes, e.g. the
     * reason for a re-determination / change of the name, etc.
     * 
     * @return the value of field 'notes'.
     */
    public java.lang.String getNotes()
    {
        return this._notes;
    } //-- java.lang.String getNotes() 

    /**
     * Returns the value of field 'responsibleName'. The field
     * 'responsibleName' has the following description: Name of the
     * person or institution responsible for the determination.
     * 
     * @return the value of field 'responsibleName'.
     */
    public java.lang.String getResponsibleName()
    {
        return this._responsibleName;
    } //-- java.lang.String getResponsibleName() 

    /**
     * Returns the value of field 'taxonomicName'. The field
     * 'taxonomicName' has the following description: Valid name of
     * the species (including the taxonomic author where available.
     * Example: 'Rosa canina L.'.
     * 
     * @return the value of field 'taxonomicName'.
     */
    public java.lang.String getTaxonomicName()
    {
        return this._taxonomicName;
    } //-- java.lang.String getTaxonomicName() 

    /**
     * Returns the value of field 'vernacularName'. The field
     * 'vernacularName' has the following description: Name other
     * than a taxonomic (= scientific) name, e.g. 'pine',
     * 'limestone', 'conifer', 'hardwood'.
     * 
     * @return the value of field 'vernacularName'.
     */
    public java.lang.String getVernacularName()
    {
        return this._vernacularName;
    } //-- java.lang.String getVernacularName() 

    /**
     * Method hasCollectionSpecimenID
     */
    public boolean hasCollectionSpecimenID()
    {
        return this._has_collectionSpecimenID;
    } //-- boolean hasCollectionSpecimenID() 

    /**
     * Method hasIdentificationDay
     */
    public boolean hasIdentificationDay()
    {
        return this._has_identificationDay;
    } //-- boolean hasIdentificationDay() 

    /**
     * Method hasIdentificationMonth
     */
    public boolean hasIdentificationMonth()
    {
        return this._has_identificationMonth;
    } //-- boolean hasIdentificationMonth() 

    /**
     * Method hasIdentificationUnitID
     */
    public boolean hasIdentificationUnitID()
    {
        return this._has_identificationUnitID;
    } //-- boolean hasIdentificationUnitID() 

    /**
     * Method hasIdentificationYear
     */
    public boolean hasIdentificationYear()
    {
        return this._has_identificationYear;
    } //-- boolean hasIdentificationYear() 

    /**
     * Method hasIsExsiccataTaxon
     */
    public boolean hasIsExsiccataTaxon()
    {
        return this._has_isExsiccataTaxon;
    } //-- boolean hasIsExsiccataTaxon() 

    /**
     * Method hasIsLastIdentificationCache
     */
    public boolean hasIsLastIdentificationCache()
    {
        return this._has_isLastIdentificationCache;
    } //-- boolean hasIsLastIdentificationCache() 

    /**
     * Method hasLogCreatedBy
     */
    public boolean hasLogCreatedBy()
    {
        return this._has_logCreatedBy;
    } //-- boolean hasLogCreatedBy() 

    /**
     * Method hasNomID
     */
    public boolean hasNomID()
    {
        return this._has_nomID;
    } //-- boolean hasNomID() 

    /**
     * Method hasNomThesaurusSignature
     */
    public boolean hasNomThesaurusSignature()
    {
        return this._has_nomThesaurusSignature;
    } //-- boolean hasNomThesaurusSignature() 

    /**
     * Method isValid
     */
    public boolean isValid()
    {
        try {
            validate();
        }
        catch (org.exolab.castor.xml.ValidationException vex) {
            return false;
        }
        return true;
    } //-- boolean isValid() 

    /**
     * Method marshal
     * 
     * @param out
     */
    public void marshal(java.io.Writer out)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, out);
    } //-- void marshal(java.io.Writer) 

    /**
     * Method marshal
     * 
     * @param handler
     */
    public void marshal(org.xml.sax.ContentHandler handler)
        throws java.io.IOException, org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, handler);
    } //-- void marshal(org.xml.sax.ContentHandler) 

    /**
     * Sets the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: Refers
     * to the ID of CollectionSpecimen (= foreign key and part of
     * primary key).
     * 
     * @param collectionSpecimenID the value of field
     * 'collectionSpecimenID'.
     */
    public void setCollectionSpecimenID(int collectionSpecimenID)
    {
        this._collectionSpecimenID = collectionSpecimenID;
        this._has_collectionSpecimenID = true;
    } //-- void setCollectionSpecimenID(int) 

    /**
     * Sets the value of field 'identificationCategory'. The field
     * 'identificationCategory' has the following description:
     * Category of the identification e.g. 'determination',
     * 'confirmation', 'absence' (= foreign key, see table
     * xColl_IdentificationCategory_Enum).
     * 
     * @param identificationCategory the value of field
     * 'identificationCategory'.
     */
    public void setIdentificationCategory(java.lang.String identificationCategory)
    {
        this._identificationCategory = identificationCategory;
    } //-- void setIdentificationCategory(java.lang.String) 

    /**
     * Sets the value of field 'identificationDateCache'. The field
     * 'identificationDateCache' has the following description:
     * Date of the identification event (calculated value based on
     * IdentificationDay, Month, and Year; if day or month are
     * missing they are assumed to be '1' for the purpose of the
     * date calculation).
     * 
     * @param identificationDateCache the value of field
     * 'identificationDateCache'.
     */
    public void setIdentificationDateCache(java.util.Date identificationDateCache)
    {
        this._identificationDateCache = identificationDateCache;
    } //-- void setIdentificationDateCache(java.util.Date) 

    /**
     * Sets the value of field 'identificationDateCategory'. The
     * field 'identificationDateCategory' has the following
     * description: Category of the date of the identification e.g.
     * "system", "estimated" (= foreign key, see in table
     * xColl_DateCategory_Enum).
     * 
     * @param identificationDateCategory the value of field
     * 'identificationDateCategory'.
     */
    public void setIdentificationDateCategory(java.lang.String identificationDateCategory)
    {
        this._identificationDateCategory = identificationDateCategory;
    } //-- void setIdentificationDateCategory(java.lang.String) 

    /**
     * Sets the value of field 'identificationDateSupplement'. The
     * field 'identificationDateSupplement' has the following
     * description: Verbal or additional identification date
     * information, e.g. 'end of summer 1985', 'first quarter',
     * '1888-1892'.
     * 
     * @param identificationDateSupplement the value of field
     * 'identificationDateSupplement'.
     */
    public void setIdentificationDateSupplement(java.lang.String identificationDateSupplement)
    {
        this._identificationDateSupplement = identificationDateSupplement;
    } //-- void setIdentificationDateSupplement(java.lang.String) 

    /**
     * Sets the value of field 'identificationDay'. The field
     * 'identificationDay' has the following description: The day
     * of the identification event.
     * 
     * @param identificationDay the value of field
     * 'identificationDay'.
     */
    public void setIdentificationDay(int identificationDay)
    {
        this._identificationDay = identificationDay;
        this._has_identificationDay = true;
    } //-- void setIdentificationDay(int) 

    /**
     * Sets the value of field 'identificationMonth'. The field
     * 'identificationMonth' has the following description: The
     * month of the identification event.
     * 
     * @param identificationMonth the value of field
     * 'identificationMonth'.
     */
    public void setIdentificationMonth(int identificationMonth)
    {
        this._identificationMonth = identificationMonth;
        this._has_identificationMonth = true;
    } //-- void setIdentificationMonth(int) 

    /**
     * Sets the value of field 'identificationQualifier'. The field
     * 'identificationQualifier' has the following description:
     * Qualification of the identification e.g. "cf."," aff.", "sp.
     * nov." (= foreign key, see table
     * xColl_IdentificationQualifier_Enum).
     * 
     * @param identificationQualifier the value of field
     * 'identificationQualifier'.
     */
    public void setIdentificationQualifier(java.lang.String identificationQualifier)
    {
        this._identificationQualifier = identificationQualifier;
    } //-- void setIdentificationQualifier(java.lang.String) 

    /**
     * Sets the value of field 'identificationSequence'. The field
     * 'identificationSequence' has the following description: Date
     * and time the identification was entered into the system,
     * defines the ordering of identifications (= part of primary
     * key). Note: this is usually not the date the identification
     * occurred!
     * 
     * @param identificationSequence the value of field
     * 'identificationSequence'.
     */
    public void setIdentificationSequence(java.util.Date identificationSequence)
    {
        this._identificationSequence = identificationSequence;
    } //-- void setIdentificationSequence(java.util.Date) 

    /**
     * Sets the value of field 'identificationUnitID'. The field
     * 'identificationUnitID' has the following description: Refers
     * to the ID of CollectionUnit (= foreign key and part of
     * primary key).
     * 
     * @param identificationUnitID the value of field
     * 'identificationUnitID'.
     */
    public void setIdentificationUnitID(int identificationUnitID)
    {
        this._identificationUnitID = identificationUnitID;
        this._has_identificationUnitID = true;
    } //-- void setIdentificationUnitID(int) 

    /**
     * Sets the value of field 'identificationYear'. The field
     * 'identificationYear' has the following description: The year
     * of the identification event. The year may be empty if only
     * the day or month are known.
     * 
     * @param identificationYear the value of field
     * 'identificationYear'.
     */
    public void setIdentificationYear(short identificationYear)
    {
        this._identificationYear = identificationYear;
        this._has_identificationYear = true;
    } //-- void setIdentificationYear(short) 

    /**
     * Sets the value of field 'isExsiccataTaxon'. The field
     * 'isExsiccataTaxon' has the following description: Defines
     * the name under which the collection specimen is published
     * within an exsiccate. Can be set only once per collection
     * specimen.
     * 
     * @param isExsiccataTaxon the value of field 'isExsiccataTaxon'
     */
    public void setIsExsiccataTaxon(boolean isExsiccataTaxon)
    {
        this._isExsiccataTaxon = isExsiccataTaxon;
        this._has_isExsiccataTaxon = true;
    } //-- void setIsExsiccataTaxon(boolean) 

    /**
     * Sets the value of field 'isLastIdentificationCache'. The
     * field 'isLastIdentificationCache' has the following
     * description: True if this is the most recent identification
     * for an organism. Calculated field. Note: only a single
     * record per identification unit can be set to true.
     * 
     * @param isLastIdentificationCache the value of field
     * 'isLastIdentificationCache'.
     */
    public void setIsLastIdentificationCache(boolean isLastIdentificationCache)
    {
        this._isLastIdentificationCache = isLastIdentificationCache;
        this._has_isLastIdentificationCache = true;
    } //-- void setIsLastIdentificationCache(boolean) 

    /**
     * Sets the value of field 'literatureUsed'. The field
     * 'literatureUsed' has the following description: Publications
     * or authorititative opinions of scientist used during the
     * identification process. Example: enter 'Schmeil-Fitschen
     * 1995' if this field flora was used.
     * 
     * @param literatureUsed the value of field 'literatureUsed'.
     */
    public void setLiteratureUsed(java.lang.String literatureUsed)
    {
        this._literatureUsed = literatureUsed;
    } //-- void setLiteratureUsed(java.lang.String) 

    /**
     * Sets the value of field 'logCreatedBy'. The field
     * 'logCreatedBy' has the following description: ID of user who
     * first entered (typed or imported) the data. This is the
     * operator (or typist) name, which may be different from the
     * person responsible.
     * 
     * @param logCreatedBy the value of field 'logCreatedBy'.
     */
    public void setLogCreatedBy(int logCreatedBy)
    {
        this._logCreatedBy = logCreatedBy;
        this._has_logCreatedBy = true;
    } //-- void setLogCreatedBy(int) 

    /**
     * Sets the value of field 'logCreatedWhen'. The field
     * 'logCreatedWhen' has the following description: Date and
     * time when record was first entered (= typed or imported)
     * into this system.
     * 
     * @param logCreatedWhen the value of field 'logCreatedWhen'.
     */
    public void setLogCreatedWhen(java.util.Date logCreatedWhen)
    {
        this._logCreatedWhen = logCreatedWhen;
    } //-- void setLogCreatedWhen(java.util.Date) 

    /**
     * Sets the value of field 'nomID'. The field 'nomID' has the
     * following description: Unique ID code of the taxon. Refers
     * to the NomID code of TaxonomyName (= foreign key) in the
     * DiversityTaxonomy component.
     * 
     * @param nomID the value of field 'nomID'.
     */
    public void setNomID(int nomID)
    {
        this._nomID = nomID;
        this._has_nomID = true;
    } //-- void setNomID(int) 

    /**
     * Sets the value of field 'nomThesaurusSignature'. The field
     * 'nomThesaurusSignature' has the following description:
     * Signature of the taxonomic name thesaurus from which NomID
     * is derived.
     * 
     * @param nomThesaurusSignature the value of field
     * 'nomThesaurusSignature'.
     */
    public void setNomThesaurusSignature(int nomThesaurusSignature)
    {
        this._nomThesaurusSignature = nomThesaurusSignature;
        this._has_nomThesaurusSignature = true;
    } //-- void setNomThesaurusSignature(int) 

    /**
     * Sets the value of field 'notes'. The field 'notes' has the
     * following description: User defined notes, e.g. the reason
     * for a re-determination / change of the name, etc.
     * 
     * @param notes the value of field 'notes'.
     */
    public void setNotes(java.lang.String notes)
    {
        this._notes = notes;
    } //-- void setNotes(java.lang.String) 

    /**
     * Sets the value of field 'responsibleName'. The field
     * 'responsibleName' has the following description: Name of the
     * person or institution responsible for the determination.
     * 
     * @param responsibleName the value of field 'responsibleName'.
     */
    public void setResponsibleName(java.lang.String responsibleName)
    {
        this._responsibleName = responsibleName;
    } //-- void setResponsibleName(java.lang.String) 

    /**
     * Sets the value of field 'taxonomicName'. The field
     * 'taxonomicName' has the following description: Valid name of
     * the species (including the taxonomic author where available.
     * Example: 'Rosa canina L.'.
     * 
     * @param taxonomicName the value of field 'taxonomicName'.
     */
    public void setTaxonomicName(java.lang.String taxonomicName)
    {
        this._taxonomicName = taxonomicName;
    } //-- void setTaxonomicName(java.lang.String) 

    /**
     * Sets the value of field 'vernacularName'. The field
     * 'vernacularName' has the following description: Name other
     * than a taxonomic (= scientific) name, e.g. 'pine',
     * 'limestone', 'conifer', 'hardwood'.
     * 
     * @param vernacularName the value of field 'vernacularName'.
     */
    public void setVernacularName(java.lang.String vernacularName)
    {
        this._vernacularName = vernacularName;
    } //-- void setVernacularName(java.lang.String) 

    /**
     * Method unmarshal
     * 
     * @param reader
     */
    public static java.lang.Object unmarshal(java.io.Reader reader)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        return (net.metadiversity.diversity.navigator.db.ub_094.collection.Identification) Unmarshaller.unmarshal(net.metadiversity.diversity.navigator.db.ub_094.collection.Identification.class, reader);
    } //-- java.lang.Object unmarshal(java.io.Reader) 

    /**
     * Method validate
     */
    public void validate()
        throws org.exolab.castor.xml.ValidationException
    {
        org.exolab.castor.xml.Validator validator = new org.exolab.castor.xml.Validator();
        validator.validate(this);
    } //-- void validate() 

}
