/*
 * This class was automatically generated with 
 * <a href="http://www.castor.org">Castor 0.9.5.2</a>, using an XML
 * Schema.
 * $Id: IdentificationUnit.java,v 1.1 2003/12/11 14:48:57 didi Exp $
 */

package net.metadiversity.diversity.navigator.db.ub_094.collection;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.IOException;
import java.io.Reader;
import java.io.Serializable;
import java.io.Writer;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.xml.Unmarshaller;
import org.exolab.castor.xml.ValidationException;
import org.xml.sax.ContentHandler;

/**
 * Organism that is present in or on a collection specimen.
 * 
 * @version $Revision: 1.1 $ $Date: 2003/12/11 14:48:57 $
 */
public class IdentificationUnit implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * ID of the identification unit (= part of Primary key).
     * Usually one of possibly several organisms present on the
     * collection specimen. Example: parasite with hyperparasite on
     * leaf = 3 units,
     */
    private int _identificationUnitID;

    /**
     * keeps track of state for field: _identificationUnitID
     */
    private boolean _has_identificationUnitID;

    /**
     * ID of the collection specimen on which the identification
     * unit is present (= Foreign key and part of primary key).
     */
    private int _collectionSpecimenID;

    /**
     * keeps track of state for field: _collectionSpecimenID
     */
    private boolean _has_collectionSpecimenID;

    /**
     * Taxonomic group the organism identified by this unit belongs
     * to. Groups listed in table xColl_TaxonomicGroup_Enum (=
     * foreign key).
     */
    private java.lang.String _taxonomicGroup;

    /**
     * True if the organism was only observed rather than
     * collected. It is therefore not present on the preserved
     * specimen. Example: Tree under which the collected
     * mycorrhizal fungus grew.
     */
    private boolean _onlyObserved;

    /**
     * keeps track of state for field: _onlyObserved
     */
    private boolean _has_onlyObserved;

    /**
     * If identification unit is type of a taxonomic name:
     * holotype, syntype, etc.
     */
    private java.lang.String _typeStatus;

    /**
     * Scientific name of the taxon typified by this identification
     * unit.
     */
    private java.lang.String _typifiedTaxon;

    /**
     * The IdentificationUnitID of the organism or substrate, on
     * which this organism is growing (= foreign key).
     */
    private int _substrateID;

    /**
     * keeps track of state for field: _substrateID
     */
    private boolean _has_substrateID;

    /**
     * If a SubstrateAssociation exists: part of the substrate that
     * is affected in the interaction (e.g. 'leaves').
     */
    private java.lang.String _colonisedPart;

    /**
     * Examples: 'II, III' for spore generations of rusts or
     * 'seed', 'seedling' etc. for higher plants.
     */
    private java.lang.String _lifeStage;

    /**
     * Further information on the identification unit or
     * interaction, e. g. infection symptoms like 'producing galls'.
     */
    private java.lang.String _notes;


      //----------------/
     //- Constructors -/
    //----------------/

    public IdentificationUnit() {
        super();
    } //-- net.metadiversity.diversity.navigator.db.ub_094.collection.IdentificationUnit()


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method deleteSubstrateID
     */
    public void deleteSubstrateID()
    {
        this._has_substrateID= false;
    } //-- void deleteSubstrateID() 

    /**
     * Returns the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: ID of
     * the collection specimen on which the identification unit is
     * present (= Foreign key and part of primary key).
     * 
     * @return the value of field 'collectionSpecimenID'.
     */
    public int getCollectionSpecimenID()
    {
        return this._collectionSpecimenID;
    } //-- int getCollectionSpecimenID() 

    /**
     * Returns the value of field 'colonisedPart'. The field
     * 'colonisedPart' has the following description: If a
     * SubstrateAssociation exists: part of the substrate that is
     * affected in the interaction (e.g. 'leaves').
     * 
     * @return the value of field 'colonisedPart'.
     */
    public java.lang.String getColonisedPart()
    {
        return this._colonisedPart;
    } //-- java.lang.String getColonisedPart() 

    /**
     * Returns the value of field 'identificationUnitID'. The field
     * 'identificationUnitID' has the following description: ID of
     * the identification unit (= part of Primary key). Usually one
     * of possibly several organisms present on the collection
     * specimen. Example: parasite with hyperparasite on leaf = 3
     * units,
     * 
     * @return the value of field 'identificationUnitID'.
     */
    public int getIdentificationUnitID()
    {
        return this._identificationUnitID;
    } //-- int getIdentificationUnitID() 

    /**
     * Returns the value of field 'lifeStage'. The field
     * 'lifeStage' has the following description: Examples: 'II,
     * III' for spore generations of rusts or 'seed', 'seedling'
     * etc. for higher plants.
     * 
     * @return the value of field 'lifeStage'.
     */
    public java.lang.String getLifeStage()
    {
        return this._lifeStage;
    } //-- java.lang.String getLifeStage() 

    /**
     * Returns the value of field 'notes'. The field 'notes' has
     * the following description: Further information on the
     * identification unit or interaction, e. g. infection symptoms
     * like 'producing galls'.
     * 
     * @return the value of field 'notes'.
     */
    public java.lang.String getNotes()
    {
        return this._notes;
    } //-- java.lang.String getNotes() 

    /**
     * Returns the value of field 'onlyObserved'. The field
     * 'onlyObserved' has the following description: True if the
     * organism was only observed rather than collected. It is
     * therefore not present on the preserved specimen. Example:
     * Tree under which the collected mycorrhizal fungus grew.
     * 
     * @return the value of field 'onlyObserved'.
     */
    public boolean getOnlyObserved()
    {
        return this._onlyObserved;
    } //-- boolean getOnlyObserved() 

    /**
     * Returns the value of field 'substrateID'. The field
     * 'substrateID' has the following description: The
     * IdentificationUnitID of the organism or substrate, on which
     * this organism is growing (= foreign key).
     * 
     * @return the value of field 'substrateID'.
     */
    public int getSubstrateID()
    {
        return this._substrateID;
    } //-- int getSubstrateID() 

    /**
     * Returns the value of field 'taxonomicGroup'. The field
     * 'taxonomicGroup' has the following description: Taxonomic
     * group the organism identified by this unit belongs to.
     * Groups listed in table xColl_TaxonomicGroup_Enum (= foreign
     * key).
     * 
     * @return the value of field 'taxonomicGroup'.
     */
    public java.lang.String getTaxonomicGroup()
    {
        return this._taxonomicGroup;
    } //-- java.lang.String getTaxonomicGroup() 

    /**
     * Returns the value of field 'typeStatus'. The field
     * 'typeStatus' has the following description: If
     * identification unit is type of a taxonomic name: holotype,
     * syntype, etc.
     * 
     * @return the value of field 'typeStatus'.
     */
    public java.lang.String getTypeStatus()
    {
        return this._typeStatus;
    } //-- java.lang.String getTypeStatus() 

    /**
     * Returns the value of field 'typifiedTaxon'. The field
     * 'typifiedTaxon' has the following description: Scientific
     * name of the taxon typified by this identification unit.
     * 
     * @return the value of field 'typifiedTaxon'.
     */
    public java.lang.String getTypifiedTaxon()
    {
        return this._typifiedTaxon;
    } //-- java.lang.String getTypifiedTaxon() 

    /**
     * Method hasCollectionSpecimenID
     */
    public boolean hasCollectionSpecimenID()
    {
        return this._has_collectionSpecimenID;
    } //-- boolean hasCollectionSpecimenID() 

    /**
     * Method hasIdentificationUnitID
     */
    public boolean hasIdentificationUnitID()
    {
        return this._has_identificationUnitID;
    } //-- boolean hasIdentificationUnitID() 

    /**
     * Method hasOnlyObserved
     */
    public boolean hasOnlyObserved()
    {
        return this._has_onlyObserved;
    } //-- boolean hasOnlyObserved() 

    /**
     * Method hasSubstrateID
     */
    public boolean hasSubstrateID()
    {
        return this._has_substrateID;
    } //-- boolean hasSubstrateID() 

    /**
     * Method isValid
     */
    public boolean isValid()
    {
        try {
            validate();
        }
        catch (org.exolab.castor.xml.ValidationException vex) {
            return false;
        }
        return true;
    } //-- boolean isValid() 

    /**
     * Method marshal
     * 
     * @param out
     */
    public void marshal(java.io.Writer out)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, out);
    } //-- void marshal(java.io.Writer) 

    /**
     * Method marshal
     * 
     * @param handler
     */
    public void marshal(org.xml.sax.ContentHandler handler)
        throws java.io.IOException, org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, handler);
    } //-- void marshal(org.xml.sax.ContentHandler) 

    /**
     * Sets the value of field 'collectionSpecimenID'. The field
     * 'collectionSpecimenID' has the following description: ID of
     * the collection specimen on which the identification unit is
     * present (= Foreign key and part of primary key).
     * 
     * @param collectionSpecimenID the value of field
     * 'collectionSpecimenID'.
     */
    public void setCollectionSpecimenID(int collectionSpecimenID)
    {
        this._collectionSpecimenID = collectionSpecimenID;
        this._has_collectionSpecimenID = true;
    } //-- void setCollectionSpecimenID(int) 

    /**
     * Sets the value of field 'colonisedPart'. The field
     * 'colonisedPart' has the following description: If a
     * SubstrateAssociation exists: part of the substrate that is
     * affected in the interaction (e.g. 'leaves').
     * 
     * @param colonisedPart the value of field 'colonisedPart'.
     */
    public void setColonisedPart(java.lang.String colonisedPart)
    {
        this._colonisedPart = colonisedPart;
    } //-- void setColonisedPart(java.lang.String) 

    /**
     * Sets the value of field 'identificationUnitID'. The field
     * 'identificationUnitID' has the following description: ID of
     * the identification unit (= part of Primary key). Usually one
     * of possibly several organisms present on the collection
     * specimen. Example: parasite with hyperparasite on leaf = 3
     * units,
     * 
     * @param identificationUnitID the value of field
     * 'identificationUnitID'.
     */
    public void setIdentificationUnitID(int identificationUnitID)
    {
        this._identificationUnitID = identificationUnitID;
        this._has_identificationUnitID = true;
    } //-- void setIdentificationUnitID(int) 

    /**
     * Sets the value of field 'lifeStage'. The field 'lifeStage'
     * has the following description: Examples: 'II, III' for spore
     * generations of rusts or 'seed', 'seedling' etc. for higher
     * plants.
     * 
     * @param lifeStage the value of field 'lifeStage'.
     */
    public void setLifeStage(java.lang.String lifeStage)
    {
        this._lifeStage = lifeStage;
    } //-- void setLifeStage(java.lang.String) 

    /**
     * Sets the value of field 'notes'. The field 'notes' has the
     * following description: Further information on the
     * identification unit or interaction, e. g. infection symptoms
     * like 'producing galls'.
     * 
     * @param notes the value of field 'notes'.
     */
    public void setNotes(java.lang.String notes)
    {
        this._notes = notes;
    } //-- void setNotes(java.lang.String) 

    /**
     * Sets the value of field 'onlyObserved'. The field
     * 'onlyObserved' has the following description: True if the
     * organism was only observed rather than collected. It is
     * therefore not present on the preserved specimen. Example:
     * Tree under which the collected mycorrhizal fungus grew.
     * 
     * @param onlyObserved the value of field 'onlyObserved'.
     */
    public void setOnlyObserved(boolean onlyObserved)
    {
        this._onlyObserved = onlyObserved;
        this._has_onlyObserved = true;
    } //-- void setOnlyObserved(boolean) 

    /**
     * Sets the value of field 'substrateID'. The field
     * 'substrateID' has the following description: The
     * IdentificationUnitID of the organism or substrate, on which
     * this organism is growing (= foreign key).
     * 
     * @param substrateID the value of field 'substrateID'.
     */
    public void setSubstrateID(int substrateID)
    {
        this._substrateID = substrateID;
        this._has_substrateID = true;
    } //-- void setSubstrateID(int) 

    /**
     * Sets the value of field 'taxonomicGroup'. The field
     * 'taxonomicGroup' has the following description: Taxonomic
     * group the organism identified by this unit belongs to.
     * Groups listed in table xColl_TaxonomicGroup_Enum (= foreign
     * key).
     * 
     * @param taxonomicGroup the value of field 'taxonomicGroup'.
     */
    public void setTaxonomicGroup(java.lang.String taxonomicGroup)
    {
        this._taxonomicGroup = taxonomicGroup;
    } //-- void setTaxonomicGroup(java.lang.String) 

    /**
     * Sets the value of field 'typeStatus'. The field 'typeStatus'
     * has the following description: If identification unit is
     * type of a taxonomic name: holotype, syntype, etc.
     * 
     * @param typeStatus the value of field 'typeStatus'.
     */
    public void setTypeStatus(java.lang.String typeStatus)
    {
        this._typeStatus = typeStatus;
    } //-- void setTypeStatus(java.lang.String) 

    /**
     * Sets the value of field 'typifiedTaxon'. The field
     * 'typifiedTaxon' has the following description: Scientific
     * name of the taxon typified by this identification unit.
     * 
     * @param typifiedTaxon the value of field 'typifiedTaxon'.
     */
    public void setTypifiedTaxon(java.lang.String typifiedTaxon)
    {
        this._typifiedTaxon = typifiedTaxon;
    } //-- void setTypifiedTaxon(java.lang.String) 

    /**
     * Method unmarshal
     * 
     * @param reader
     */
    public static java.lang.Object unmarshal(java.io.Reader reader)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        return (net.metadiversity.diversity.navigator.db.ub_094.collection.IdentificationUnit) Unmarshaller.unmarshal(net.metadiversity.diversity.navigator.db.ub_094.collection.IdentificationUnit.class, reader);
    } //-- java.lang.Object unmarshal(java.io.Reader) 

    /**
     * Method validate
     */
    public void validate()
        throws org.exolab.castor.xml.ValidationException
    {
        org.exolab.castor.xml.Validator validator = new org.exolab.castor.xml.Validator();
        validator.validate(this);
    } //-- void validate() 

}
