/*
 * This class was automatically generated with 
 * <a href="http://www.castor.org">Castor 0.9.5.2</a>, using an XML
 * Schema.
 * $Id: LocalisationSystem.java,v 1.1 2003/12/11 14:48:57 didi Exp $
 */

package net.metadiversity.diversity.navigator.db.ub_094.collection;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.IOException;
import java.io.Reader;
import java.io.Serializable;
import java.io.Writer;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.xml.Unmarshaller;
import org.exolab.castor.xml.ValidationException;
import org.xml.sax.ContentHandler;

/**
 * Localisation system used for the determination of the
 * geographical data.
 * 
 * @version $Revision: 1.1 $ $Date: 2003/12/11 14:48:57 $
 */
public class LocalisationSystem implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Unique ID for the localisation system (= Primary key).
     */
    private int _localisationSystemID;

    /**
     * keeps track of state for field: _localisationSystemID
     */
    private boolean _has_localisationSystemID;

    /**
     * Name of the system used for the determination of the place
     * of the collection, e. g. Gauss-Krger, MTB, GIS.
     */
    private java.lang.String _localisationSystemName;

    /**
     * Refers to the ID of a LocalisationSystemType (= Foreign key).
     */
    private int _localisationSystemTypeID;

    /**
     * keeps track of state for field: _localisationSystemTypeID
     */
    private boolean _has_localisationSystemTypeID;

    /**
     * User interface definition: locked status, label captions,
     * etc.; used e. g. in the form CollectionLocality.
     */
    private java.lang.String _interfaceDefinitions;

    /**
     * Description of the localisation method.
     */
    private java.lang.String _description;

    /**
     * Measurement unit used within the localisation system, e.g.
     * m, miles etc. Metric units should be preferred.
     */
    private java.lang.String _measurementUnit;

    /**
     * A description of the accuracy of values that can be reached
     * with this method.
     */
    private java.lang.String _accuracyOfLocalisation;

    /**
     * Internal value, specifying a programming method used for
     * parsing text in fields Location1/Location2 in table
     * CollectionGeography.
     */
    private java.lang.String _parsingMethod;

    /**
     * Specifies if this item is enabled to be used within the
     * database. LocalisationSystems can be disabled to avoid
     * seeing them, but to keep the definition for the future.
     */
    private boolean _enabled;

    /**
     * keeps track of state for field: _enabled
     */
    private boolean _has_enabled;


      //----------------/
     //- Constructors -/
    //----------------/

    public LocalisationSystem() {
        super();
    } //-- net.metadiversity.diversity.navigator.db.ub_094.collection.LocalisationSystem()


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Returns the value of field 'accuracyOfLocalisation'. The
     * field 'accuracyOfLocalisation' has the following
     * description: A description of the accuracy of values that
     * can be reached with this method.
     * 
     * @return the value of field 'accuracyOfLocalisation'.
     */
    public java.lang.String getAccuracyOfLocalisation()
    {
        return this._accuracyOfLocalisation;
    } //-- java.lang.String getAccuracyOfLocalisation() 

    /**
     * Returns the value of field 'description'. The field
     * 'description' has the following description: Description of
     * the localisation method.
     * 
     * @return the value of field 'description'.
     */
    public java.lang.String getDescription()
    {
        return this._description;
    } //-- java.lang.String getDescription() 

    /**
     * Returns the value of field 'enabled'. The field 'enabled'
     * has the following description: Specifies if this item is
     * enabled to be used within the database. LocalisationSystems
     * can be disabled to avoid seeing them, but to keep the
     * definition for the future.
     * 
     * @return the value of field 'enabled'.
     */
    public boolean getEnabled()
    {
        return this._enabled;
    } //-- boolean getEnabled() 

    /**
     * Returns the value of field 'interfaceDefinitions'. The field
     * 'interfaceDefinitions' has the following description: User
     * interface definition: locked status, label captions, etc.;
     * used e. g. in the form CollectionLocality.
     * 
     * @return the value of field 'interfaceDefinitions'.
     */
    public java.lang.String getInterfaceDefinitions()
    {
        return this._interfaceDefinitions;
    } //-- java.lang.String getInterfaceDefinitions() 

    /**
     * Returns the value of field 'localisationSystemID'. The field
     * 'localisationSystemID' has the following description: Unique
     * ID for the localisation system (= Primary key).
     * 
     * @return the value of field 'localisationSystemID'.
     */
    public int getLocalisationSystemID()
    {
        return this._localisationSystemID;
    } //-- int getLocalisationSystemID() 

    /**
     * Returns the value of field 'localisationSystemName'. The
     * field 'localisationSystemName' has the following
     * description: Name of the system used for the determination
     * of the place of the collection, e. g. Gauss-Krger, MTB,
     * GIS.
     * 
     * @return the value of field 'localisationSystemName'.
     */
    public java.lang.String getLocalisationSystemName()
    {
        return this._localisationSystemName;
    } //-- java.lang.String getLocalisationSystemName() 

    /**
     * Returns the value of field 'localisationSystemTypeID'. The
     * field 'localisationSystemTypeID' has the following
     * description: Refers to the ID of a LocalisationSystemType (=
     * Foreign key).
     * 
     * @return the value of field 'localisationSystemTypeID'.
     */
    public int getLocalisationSystemTypeID()
    {
        return this._localisationSystemTypeID;
    } //-- int getLocalisationSystemTypeID() 

    /**
     * Returns the value of field 'measurementUnit'. The field
     * 'measurementUnit' has the following description: Measurement
     * unit used within the localisation system, e.g. m, miles etc.
     * Metric units should be preferred.
     * 
     * @return the value of field 'measurementUnit'.
     */
    public java.lang.String getMeasurementUnit()
    {
        return this._measurementUnit;
    } //-- java.lang.String getMeasurementUnit() 

    /**
     * Returns the value of field 'parsingMethod'. The field
     * 'parsingMethod' has the following description: Internal
     * value, specifying a programming method used for parsing text
     * in fields Location1/Location2 in table CollectionGeography.
     * 
     * @return the value of field 'parsingMethod'.
     */
    public java.lang.String getParsingMethod()
    {
        return this._parsingMethod;
    } //-- java.lang.String getParsingMethod() 

    /**
     * Method hasEnabled
     */
    public boolean hasEnabled()
    {
        return this._has_enabled;
    } //-- boolean hasEnabled() 

    /**
     * Method hasLocalisationSystemID
     */
    public boolean hasLocalisationSystemID()
    {
        return this._has_localisationSystemID;
    } //-- boolean hasLocalisationSystemID() 

    /**
     * Method hasLocalisationSystemTypeID
     */
    public boolean hasLocalisationSystemTypeID()
    {
        return this._has_localisationSystemTypeID;
    } //-- boolean hasLocalisationSystemTypeID() 

    /**
     * Method isValid
     */
    public boolean isValid()
    {
        try {
            validate();
        }
        catch (org.exolab.castor.xml.ValidationException vex) {
            return false;
        }
        return true;
    } //-- boolean isValid() 

    /**
     * Method marshal
     * 
     * @param out
     */
    public void marshal(java.io.Writer out)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, out);
    } //-- void marshal(java.io.Writer) 

    /**
     * Method marshal
     * 
     * @param handler
     */
    public void marshal(org.xml.sax.ContentHandler handler)
        throws java.io.IOException, org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, handler);
    } //-- void marshal(org.xml.sax.ContentHandler) 

    /**
     * Sets the value of field 'accuracyOfLocalisation'. The field
     * 'accuracyOfLocalisation' has the following description: A
     * description of the accuracy of values that can be reached
     * with this method.
     * 
     * @param accuracyOfLocalisation the value of field
     * 'accuracyOfLocalisation'.
     */
    public void setAccuracyOfLocalisation(java.lang.String accuracyOfLocalisation)
    {
        this._accuracyOfLocalisation = accuracyOfLocalisation;
    } //-- void setAccuracyOfLocalisation(java.lang.String) 

    /**
     * Sets the value of field 'description'. The field
     * 'description' has the following description: Description of
     * the localisation method.
     * 
     * @param description the value of field 'description'.
     */
    public void setDescription(java.lang.String description)
    {
        this._description = description;
    } //-- void setDescription(java.lang.String) 

    /**
     * Sets the value of field 'enabled'. The field 'enabled' has
     * the following description: Specifies if this item is enabled
     * to be used within the database. LocalisationSystems can be
     * disabled to avoid seeing them, but to keep the definition
     * for the future.
     * 
     * @param enabled the value of field 'enabled'.
     */
    public void setEnabled(boolean enabled)
    {
        this._enabled = enabled;
        this._has_enabled = true;
    } //-- void setEnabled(boolean) 

    /**
     * Sets the value of field 'interfaceDefinitions'. The field
     * 'interfaceDefinitions' has the following description: User
     * interface definition: locked status, label captions, etc.;
     * used e. g. in the form CollectionLocality.
     * 
     * @param interfaceDefinitions the value of field
     * 'interfaceDefinitions'.
     */
    public void setInterfaceDefinitions(java.lang.String interfaceDefinitions)
    {
        this._interfaceDefinitions = interfaceDefinitions;
    } //-- void setInterfaceDefinitions(java.lang.String) 

    /**
     * Sets the value of field 'localisationSystemID'. The field
     * 'localisationSystemID' has the following description: Unique
     * ID for the localisation system (= Primary key).
     * 
     * @param localisationSystemID the value of field
     * 'localisationSystemID'.
     */
    public void setLocalisationSystemID(int localisationSystemID)
    {
        this._localisationSystemID = localisationSystemID;
        this._has_localisationSystemID = true;
    } //-- void setLocalisationSystemID(int) 

    /**
     * Sets the value of field 'localisationSystemName'. The field
     * 'localisationSystemName' has the following description: Name
     * of the system used for the determination of the place of the
     * collection, e. g. Gauss-Krger, MTB, GIS.
     * 
     * @param localisationSystemName the value of field
     * 'localisationSystemName'.
     */
    public void setLocalisationSystemName(java.lang.String localisationSystemName)
    {
        this._localisationSystemName = localisationSystemName;
    } //-- void setLocalisationSystemName(java.lang.String) 

    /**
     * Sets the value of field 'localisationSystemTypeID'. The
     * field 'localisationSystemTypeID' has the following
     * description: Refers to the ID of a LocalisationSystemType (=
     * Foreign key).
     * 
     * @param localisationSystemTypeID the value of field
     * 'localisationSystemTypeID'.
     */
    public void setLocalisationSystemTypeID(int localisationSystemTypeID)
    {
        this._localisationSystemTypeID = localisationSystemTypeID;
        this._has_localisationSystemTypeID = true;
    } //-- void setLocalisationSystemTypeID(int) 

    /**
     * Sets the value of field 'measurementUnit'. The field
     * 'measurementUnit' has the following description: Measurement
     * unit used within the localisation system, e.g. m, miles etc.
     * Metric units should be preferred.
     * 
     * @param measurementUnit the value of field 'measurementUnit'.
     */
    public void setMeasurementUnit(java.lang.String measurementUnit)
    {
        this._measurementUnit = measurementUnit;
    } //-- void setMeasurementUnit(java.lang.String) 

    /**
     * Sets the value of field 'parsingMethod'. The field
     * 'parsingMethod' has the following description: Internal
     * value, specifying a programming method used for parsing text
     * in fields Location1/Location2 in table CollectionGeography.
     * 
     * @param parsingMethod the value of field 'parsingMethod'.
     */
    public void setParsingMethod(java.lang.String parsingMethod)
    {
        this._parsingMethod = parsingMethod;
    } //-- void setParsingMethod(java.lang.String) 

    /**
     * Method unmarshal
     * 
     * @param reader
     */
    public static java.lang.Object unmarshal(java.io.Reader reader)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        return (net.metadiversity.diversity.navigator.db.ub_094.collection.LocalisationSystem) Unmarshaller.unmarshal(net.metadiversity.diversity.navigator.db.ub_094.collection.LocalisationSystem.class, reader);
    } //-- java.lang.Object unmarshal(java.io.Reader) 

    /**
     * Method validate
     */
    public void validate()
        throws org.exolab.castor.xml.ValidationException
    {
        org.exolab.castor.xml.Validator validator = new org.exolab.castor.xml.Validator();
        validator.validate(this);
    } //-- void validate() 

}
