/*
 * UbtCollectionProjectPlugin.java
 *
 * Created on 18. November 2003, 16:15
 */

package net.metadiversity.diversity.navigator.projectPlugin;

import org.apache.log4j.Logger;

import net.metadiversity.diversity.navigator.gui.ProjectQueryPanel;
import net.metadiversity.diversity.navigator.gui.delta_editor.DeltaEditor;

/**
 *
 * @author  Dieter Neubacher
 */
public class DeltaEditorProjectPlugin extends Plugin
{
    static Logger logger = Logger.getLogger( DeltaEditorProjectPlugin.class.getName() );
    
    /** Creates a new instance of UbtCollectionProjectPlugin */
    public DeltaEditorProjectPlugin()
    {
        super( "Delta Editor", "Diversity Workbanch" );

        String delta_editor_database = "LIAS Light Descriptive Data";
        addProjectDatabase( null, delta_editor_database );
        
        java.sql.Connection con = null;        
        try
        {
            net.metadiversity.diversity.navigator.connection.ConnectionInfo ci;        
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( delta_editor_database );
            con = ci.getConnection();
            logger.info( "Connect to: " + ci.getUrl() );
            
        }
        catch( java.sql.SQLException ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        catch( Exception ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        String tablePrefix = "LIASlight";
        javax.swing.JPanel p = new DeltaEditor( con, tablePrefix );        
        this.setGridViewPanel( p );
        this.pack();
        this.setVisible( true );
    }
}
