/*
 * UbtCollectionProjectPlugin.java
 *
 * Created on 18. November 2003, 16:15
 */

package net.metadiversity.diversity.navigator.projectPlugin;

import org.apache.log4j.Logger;

import net.metadiversity.diversity.navigator.connection.ConnectionInfo;
import net.metadiversity.diversity.navigator.gui.ProjectQueryPanel;
import net.metadiversity.diversity.navigator.gui.CollectionTransectGisVisualisation;
import net.metadiversity.diversity.navigator.gui.delta_editor.DeltaEditor;

/**
 *
 * @author  Dieter Neubacher
 */
public class UbtCollectionProjectPlugin extends Plugin
{
    static Logger logger = Logger.getLogger( UbtCollectionProjectPlugin.class.getName() );
    
    /** Creates a new instance of UbtCollectionProjectPlugin */
    public UbtCollectionProjectPlugin()
    {
        super( "BIOTA S04 Lichens", "Diversity Workbanch" );
        
        addProjectDatabase( null, "UBT BIOTA Lichen Collections" );
        addProjectDatabase( null, "UBT BIOTA Lichen Descriptions" );
        
        java.sql.Connection conDesc = null;
        java.sql.Connection conColl = null;
        
        ConnectionInfo ciDesc = null;        
        ConnectionInfo ciColl = null;        
        try
        {
            ciDesc = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( "UBT BIOTA Lichen Descriptions" );
            conDesc = ciDesc.getConnection();
            logger.info( "Connect to: " + ciDesc.getUrl() );
            
            ciColl = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( "UBT BIOTA Lichen Collections" );
            conColl = ciColl.getConnection();
            logger.info( "Connect to: " + ciColl.getUrl() );            
        }
        catch( java.sql.SQLException ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        catch( Exception ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        
        setMapPanel( new CollectionTransectGisVisualisation( conDesc, conColl ) );
        
        // Set Form for UbtCollection (Version: ??? old)
        // ??? Castor config
        net.metadiversity.diversity.navigator.db.ub.UbtCollectionMainFrame dataForm = new net.metadiversity.diversity.navigator.db.ub.UbtCollectionMainFrame( ciColl );
        setDataFormPanel( dataForm );

        // setup DeltaEditor for description database
        String tablePrefix =  "BIOTAlichendescr"; //"BIOTA_S04"; // ??? No Column StateID  in CS       
        javax.swing.JPanel p = new DeltaEditor( conDesc, tablePrefix );        
        this.setGridViewPanel( p );        
        this.pack();
        this.setVisible( true );
    }
}
